#!/usr/bin/env python
# -*- coding: UTF8 -*-
# Copyright (C) 2008 by Daniel Martin Yerga
# <dyerga@gmail.com>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

# Maemo WordPy: Blogging client for Internet Tablets
# Version 0.6
#
# MaemoWordPy is based in WordPy, so it have some parts of Wordpy code.
# (http://www.learningpython.com/2006/08/19/wordpress-python-library/), 
# 
# Also it has parts of Mirage Image Viewer code (http://mirageiv.berlios.de). 
# All functions for cropping images are from Mirage, and some code 
# for grab screenshots.
#
import os
import sys
import gtk
import gtk.glade
import gobject
import osso
import hildon
import pango
import ConfigParser
from xml.dom import minidom
import thread
try:
	import wordpresslib
except:
	print 'Wordpresslib module not loaded.'
	sys.exit(1)

try:
	import flickrapi
except:
	print 'Flickrapi module not loaded.'
	sys.exit(1)

try:
	import gdata
	import gdata.service
	import atom
except:
	print 'Gdata module not loaded.'
	sys.exit(1)

try:
	import gdata.photos.service
	picasa = True
except:
	print 'Picasa upload desactivated.'
	picasa = False

#import jaiku
api_key = 'c5c97bf7c85c7a5351cf9e1a2a433678'
secret = 'a20834f00befce6a'
flickr = flickrapi.FlickrAPI(api_key, secret)
#jaiku_api = jaiku.Api(username='yerga', api_key='api')

osso_c = osso.Context("maemo_wordpy", "0.6.1", False)

## if you use OS2008, distro = 'chinook'
## else, distro = 'bora'
distro = 'bora'
## if run wordpy in local directory running = 'sdk'
## else running = 'OS' or anything
running = 'OS'
## Check it and get paths ##
if running == 'sdk':
	configdir = ''
	appdir = ''
	imgdir = 'pixmaps/'
else:
	configdir = '/home/user/.maemowordpy/'
	appdir = '/usr/share/maemo-wordpy/'
	imgdir = appdir + 'pixmaps/'

##Check if there is settings, if not create new ##
## If file is corrupted, create new ##
## If settings.conf haven't fontsize (new feature), add it ###
def if_config_not_exist_create_it():
	if os.path.exists(configdir + "settings.conf"):
		print 'settings.conf exist'
		settings_conf =  open(configdir + "settings.conf", "r")
		settings_read = settings_conf.read()
		settings_conf.close()
		if settings_read.find('[Settings]') < 0:
			print 'settings.conf is corrupted'
			create_settings_files('settings')
		elif settings_read.find('fontsize') < 0:
			print 'Not fontsize setting. Creating it.'
			new_settings_conf = open(configdir + "settings.conf", "w")
			new_settings_conf.write(settings_read + 'fontsize = 14')
			new_settings_conf.close()
		del settings_read
	else:
		create_settings_files('settings')

	if os.path.exists(configdir + "accounts.conf"):
		print 'accounts.conf exist'
		accounts_conf =  open(configdir + "accounts.conf", "r")
		if accounts_conf.read() == '':
			print 'accounts.conf is corrupted'
			create_settings_files('accounts')
		accounts_conf.close()
	else:
		create_settings_files('accounts')

def create_settings_files(setting):
	if setting == 'accounts':
		print 'creating new accounts.conf'
		new_config = "[wordpress]\nurl = http://blog.test.com/xmlrpc.php\npassword = password\nenabled = True\nuser = user\nblogsystem = Wordpress\nblogid = None\nblogtitle = None\n\n[blogger]\nurl = \npassword = \nenabled = False\nuser = GmailID\nblogsystem = Blogger\nblogid = 123456\nblogtitle = title"
		fileconfig = open(configdir + "accounts.conf", "w")
		fileconfig.write(new_config)
		fileconfig.close()		
	if setting == 'settings':
		print 'creating new settings.conf'
		new_config = "[Settings]\nfingerscroll = True\nflickrphotos = 4\nnum_articles = 8\nfontsize = 14"
		fileconfig = open(configdir + "settings.conf", "w")
		fileconfig.write(new_config)
		fileconfig.close()
##Run the function
if_config_not_exist_create_it()

##Initialize the config and accounts
config = ConfigParser.SafeConfigParser()
config.read(configdir + "settings.conf")

accounts = ConfigParser.SafeConfigParser()
accounts.read(configdir + "accounts.conf")

##Get glade filenames
glade_file = appdir + "maemo-wordpy.glade"
preferences_glade = appdir + "accounts.glade"
upload_glade = appdir + "upload.glade"	

# Columns for liststore for Categories/Articles/Accounts
(COLUMN_FIXED, COLUMN_DESCRIPTION) = range(2)
(COLUMN_ARTICLE_FIXED, COLUMN_ARTICLE, COLUMN_ID) = range(3)
(ENABLED, ACCOUNTTITLE, BLOGURL, BLOGUSER, BLOGSYSTEM, BLOGPASS, BLOGID, BLOGTITLE) = range(8)
(DEL_CACHE_IMAGE, CACHE_IMAGE) = range(2)
## Create lists ##
##accounts
cuentas=[]
##categories, articles
data=[]
cats=[]
idfromcat=[]
data_articles=[]
del_articles=[]
### cached images
cached_images_to_delete=[]
cached_images=[]
##flickr photolist
photos = []
photo_size = []
width_size = []
height_size	 = []
all_source = []
##flickr sets
sets = []
sets_id = []
##blogs and blog_id
blogs = []
blogs_id = []

## Extension for posts saved
FILE_EXT = "wpx"

##Tag numbers for xml .wpx file
MAIN_TAG = 0
POST_TAG = 1
TITLE_TAG = 2
TEXT_TAG = 3
EXCERPT_TAG = 4
EXTENDED_ENTRY_TAG = 5
TTAGS_TAG = 6	
TRACKS_TAG = 7
SETTINGS_TAG = 8
URL_TAG = 9
USERNAME_TAG = 10
PASSWORD_TAG = 11

gtk.gdk.threads_init()

class Wordpy(hildon.Program):


	_xml_tags = {
			MAIN_TAG : "WordPy"
			, POST_TAG : "Post"
			, TITLE_TAG : "Title"
			, TEXT_TAG : "Text"
			, EXCERPT_TAG : "Excerpt"
			, EXTENDED_ENTRY_TAG : "Entry"
			, TTAGS_TAG : "TechnoratiTags"
			, TRACKS_TAG : "Trackbacks"
			, URL_TAG : "URL"
			, SETTINGS_TAG : "Settings"
			, USERNAME_TAG : "Username"
			, PASSWORD_TAG : "Password"
	}

	def __init__(self):
		self.program = hildon.Program()
		self.program.__init__()

		self.wndMain = hildon.Window()
		self.wndMain.set_default_size(800, 480)
		self.program.add_window(self.wndMain)
		self.wndMain.connect("key-press-event", self.on_key_press)
		self.wndMain.connect("window-state-event", self.on_window_state_change)
		self.wndMain.connect("destroy", self.quit)
		#Initialize some variables
		self.window_in_fullscreen = False
		self.preserve_aspect = True
		self.ignore_preserve_aspect_callback = False
		self.new_pixbuf = None
		self.screenshot_delay = 2
		self.xml_file = None
		self.labels = False

		self.wTree=gtk.glade.XML(glade_file)
		vbox1 = self.wTree.get_widget("vbox1")
		vbox1.reparent(self.wndMain)

		## Get default account ##
		for section in accounts.sections():
			if accounts.get(section, "enabled") == 'True':
				#print 'account: ', section	
				BlogSettings.URL = accounts.get(section, "url")
				BlogSettings.Username = accounts.get(section, "user")
				BlogSettings.System = accounts.get(section, "blogsystem")
				BlogSettings.Password = accounts.get(section, "password")
				BlogSettings.Blogid = accounts.get(section, "blogid")
				BlogSettings.Blogtitle = accounts.get(section, "blogtitle")
		#print BlogSettings.URL, BlogSettings.Username, BlogSettings.System, BlogSettings.Password

		## Get settings ##
		BlogSettings.Fingermenu = config.get("Settings", "fingerscroll")
		BlogSettings.Flickr_num = int(config.get("Settings", "flickrphotos"))
		BlogSettings.Articles_num = int(config.get("Settings", "num_articles"))
		BlogSettings.Fontsize = str(config.get("Settings", "fontsize"))

		## Create menu  ##
        #get menu from glade and reparent as common menu in hildon program
		mainMenu = self.wTree.get_widget("menubar1")
		menu = gtk.Menu()
		for child in mainMenu.get_children():
			child.reparent(menu)
		self.wndMain.set_menu(menu)
		mainMenu.destroy()

		# Submenu File
		newmenu = self.wTree.get_widget("menuitem3")
		newmenu_img = gtk.Image()
		newmenu_img.set_from_file(imgdir + "gtk-new.png")
		newmenu.set_image(newmenu_img)
		newmenu.connect("activate",self.on_file_new)

		openmenu = self.wTree.get_widget("menuitem6")
		openmenu_img = gtk.Image()
		openmenu_img.set_from_file(imgdir + "gtk-open.png")
		openmenu.set_image(openmenu_img)		
		openmenu.connect("activate",self.on_file_open)

		savemenu = self.wTree.get_widget("menuitem7")
		savemenu_img = gtk.Image()
		savemenu_img.set_from_file(imgdir + "gtk-save.png")
		savemenu.set_image(savemenu_img)		
		savemenu.connect("activate",self.on_file_save)
		
		saveasmenu = self.wTree.get_widget("menuitem8")
		saveasmenu_img = gtk.Image()
		saveasmenu_img.set_from_file(imgdir + "gtk-saveas.png")
		saveasmenu.set_image(saveasmenu_img)		
		saveasmenu.connect("activate",self.on_file_save_as)		
		
		menu_exit = self.wTree.get_widget("menuitem10")
		quitmenu_img = gtk.Image()
		quitmenu_img.set_from_file(imgdir + "gtk-quit.png")
		menu_exit.set_image(quitmenu_img)				
		menu_exit.connect("activate", self.quit)

		# Submenu Edit
		cutmenu = self.wTree.get_widget("menuitem13")
		cutmenu_img = gtk.Image()
		cutmenu_img.set_from_file(imgdir + "gtk-cut.png")
		cutmenu.set_image(cutmenu_img)			
		cutmenu.connect("activate",self.on_cut)

		copymenu = self.wTree.get_widget("menuitem12")
		copymenu_img = gtk.Image()
		copymenu_img.set_from_file(imgdir + "gtk-copy.png")
		copymenu.set_image(copymenu_img)			
		copymenu.connect("activate",self.on_copy)

		pastemenu = self.wTree.get_widget("menuitem11")
		pastemenu_img = gtk.Image()
		pastemenu_img.set_from_file(imgdir + "gtk-paste.png")
		pastemenu.set_image(pastemenu_img)			
		pastemenu.connect("activate",self.on_paste)	
		
		self.toolbarmenu = self.wTree.get_widget("menuitem9")
		self.toolbarmenu.connect("toggled", self.on_view_toolbar)

		#Submenu publishing	
		menu_settings = self.wTree.get_widget("menuitem16")
		settingsmenu_img = gtk.Image()
		settingsmenu_img.set_from_file(imgdir + "gtk-preferences.png")
		menu_settings.set_image(settingsmenu_img)			
		menu_settings.connect("activate",self.on_btnSettings_clicked)

		#if not chinook add new menu for preview article in the browser		
		if distro == "bora":
			publishing_menu = self.wTree.get_widget("menu4")
			preview_menu = gtk.ImageMenuItem("Preview")
			preview_menu.connect("activate",self.on_previewmenu_clicked)
			previewmenu_img = gtk.Image()
			previewmenu_img.set_from_file(imgdir + "gtk-preview.png")
			preview_menu.set_image(previewmenu_img)
			preview_menu.show()
			publishing_menu.append(preview_menu)

		menu_flickr = self.wTree.get_widget("menuitem20")
		flickrmenu_img = gtk.Image()
		flickrmenu_img.set_from_file(imgdir + "flickr.png")
		menu_flickr.set_image(flickrmenu_img)			
		menu_flickr.connect("activate", self.on_flickr_upload_clicked)		
		
		menu_delete = self.wTree.get_widget("menuitem19")
		delmenu_img = gtk.Image()
		delmenu_img.set_from_file(imgdir + "gtk-delete.png")
		menu_delete.set_image(delmenu_img)		
		menu_delete.connect("activate",self.on_btngetarticles_clicked)
		
		menu_categories = self.wTree.get_widget("menuitem17")
		catmenu_img = gtk.Image()
		catmenu_img.set_from_file(imgdir + "gtk-index.png")
		menu_categories.set_image(catmenu_img)		
		menu_categories.connect("activate",self.on_btncategories_clicked)

		menu_post = self.wTree.get_widget("menuitem18")
		postmenu_img = gtk.Image()
		postmenu_img.set_from_file(imgdir + "gtk-up.png")
		menu_post.set_image(postmenu_img)		
		menu_post.connect("activate",self.on_btnpost_clicked)

		#Submenu about
		menu_info = self.wTree.get_widget("menuitem15")
		infomenu_img = gtk.Image()
		infomenu_img.set_from_file(imgdir + "gtk-help.png")
		menu_info.set_image(infomenu_img)		
		menu_info.connect("activate",self.on_help, 'general')

		menu_credits = self.wTree.get_widget("menuitem14")
		creditsmenu_img = gtk.Image()
		creditsmenu_img.set_from_file(imgdir + "gtk-about.png")
		menu_credits.set_image(creditsmenu_img)		
		menu_credits.connect("activate",self.on_about_credits)
		
		## Create toolbar
		self.create_toolbar()
		
		## Get glade widgets
		scrollwin = self.wTree.get_widget("scrolledwindow1")
		excerpt_win = self.wTree.get_widget("scrolledwindow3")
		extend_win = self.wTree.get_widget("scrolledwindow2")

		## Set finger scrollbars if user like it of course
		if distro == 'chinook':
			if BlogSettings.Fingermenu == 'True':
				hildon.hildon_helper_set_thumb_scrollbar(scrollwin, True)
				hildon.hildon_helper_set_thumb_scrollbar(excerpt_win, True)
				hildon.hildon_helper_set_thumb_scrollbar(extend_win, True)
		
		self.enTitle = self.wTree.get_widget("enTitle")
		self.en_track = self.wTree.get_widget("en_track")
		self.en_tags = self.wTree.get_widget("en_tags")
		self.comm_button = self.wTree.get_widget("comm_button")
		self.pub_button = self.wTree.get_widget("pub_button")
		self.ping_button = self.wTree.get_widget("allow_pings_btn")
		self.txtPost = self.wTree.get_widget("txtPost")
		self.txtPostExt = self.wTree.get_widget("txtPostExt")
		self.txtPostExc = self.wTree.get_widget("txtPostExc")
		self.set_font_textview()

		#Get the buffer associated with the text views
		self.txtBuffer = self.txtPost.get_buffer()
		self.txtBufferExt = self.txtPostExt.get_buffer()
		self.txtBufferExc = self.txtPostExc.get_buffer()

		help_tags_btn = self.wTree.get_widget("help_tags_btn")
		help_tags_btn.connect("clicked", self.on_help, 'others')

		notebook = self.wTree.get_widget("notebook1")
		pagenum = notebook.get_current_page()
		
		notebook.connect("switch_page", self.on_notebook_changed)
		# if chinook add tab with html preview without it delete tab
		if distro == 'chinook':
			swin_preview = self.wTree.get_widget("swin_preview")

			if BlogSettings.Fingermenu == 'True':
				hildon.hildon_helper_set_thumb_scrollbar(swin_preview, True)
			try:
				import gtkhtml2
			except:
				print "gtkhtml2 module not loaded."
				sys.exit(1)

			self.htmlview = gtkhtml2.View()	
			swin_preview.add(self.htmlview)
		else:
			notebook.remove_page(4)

        #destroy the gtk window imported from glade
		gtkWindow = self.wTree.get_widget("window1")
		gtkWindow.destroy()

		self.wndMain.show_all()
		
	def on_notebook_changed(self, widget, dummy, pagenum):
		if pagenum == 4:
			self.toolbar.hide()
			self.toolbarmenu.set_sensitive(False)
			banner = hildon.hildon_banner_show_animation(widget, 'qgn_indi_pball_a', 'Preview article')
			thread.start_new_thread(self.show_preview, (widget, dummy, banner))
		elif pagenum == 3:
			self.toolbar.hide()
			self.toolbarmenu.set_sensitive(False)
			if BlogSettings.System == "Blogger":
				self.en_track.set_sensitive(False)
				self.comm_button.set_sensitive(False)
				self.ping_button.set_sensitive(False)
			else:
				self.en_track.set_sensitive(True)
				self.comm_button.set_sensitive(True)
				self.ping_button.set_sensitive(True)				
		elif pagenum == 2:
			self.toolbar.show()
			self.toolbarmenu.set_sensitive(True)
			if BlogSettings.System == "Blogger":
				self.txtPostExt.set_sensitive(False)
			else:
				self.txtPostExt.set_sensitive(True)				
		elif pagenum == 1:
			self.toolbar.hide()
			self.toolbarmenu.set_sensitive(False)
			if BlogSettings.System == "Blogger":
				self.txtPostExc.set_sensitive(False)
			else:
				self.txtPostExc.set_sensitive(True)				
		elif pagenum == 0:
			self.toolbar.show()
			self.toolbarmenu.set_sensitive(True)

	def set_font_textview(self):
		self.txtPost.modify_font(pango.FontDescription("Monospace "+ BlogSettings.Fontsize))	
		self.txtPostExt.modify_font(pango.FontDescription("Monospace "+ BlogSettings.Fontsize))	
		self.txtPostExc.modify_font(pango.FontDescription("Monospace "+ BlogSettings.Fontsize))

	def show_preview(self, widget, dummy, banner):
		import gtkhtml2
		document = gtkhtml2.Document()
		document.connect('request-url', self.request_url)
		document.clear()
		document.open_stream('text/html')
		start, end = self.txtBuffer.get_bounds()
		texto_buff = self.txtBuffer.get_text(start, end)
			
		ext_start, ext_end = self.txtBufferExt.get_bounds()
		ext_texto_buff = self.txtBufferExt.get_text(ext_start, ext_end)
		if ext_texto_buff == "":
			pass
		else:
			texto_buff = texto_buff + '\n\n<a href="">[READ MORE]</a>\n\n' + ext_texto_buff
			
		html_final = texto_buff.replace("\n", "<br />")
		##CSS: <link type="text/css" rel="stylesheet" href="url"></link>
		header = '<html><head><meta http-equiv=content-type content="text/html; charset=UTF-8"></head>'
		title = "<h1>"+self.enTitle.get_text()+"</h1><br /><br />"
		body = "<body>"+title+html_final+"</body></html>"
		htmlpage = header+body
		document.write_stream(htmlpage)
		document.close_stream()
		self.htmlview.set_document(document)
		banner.destroy()

	def request_url (self, doc, url, stream):
		from gnome import gnomevfs
		try:
			f = gnomevfs.open(url, gnomevfs.OPEN_READ)
		except:
			print "Error opening url", url
			stream.close()
			return

		while 1:
			try:
				stream.write(f.read (1024))
			except gnomevfs.EOFError:
				break
		f.close()
		stream.close()

	#Functions for fullscreen
	def on_window_state_change(self, widget, event, *args):           
		if event.new_window_state & gtk.gdk.WINDOW_STATE_FULLSCREEN:
			self.window_in_fullscreen = True
		else:
			self.window_in_fullscreen = False

	def on_key_press(self, widget, event, *args):            
		if event.keyval == gtk.keysyms.F6:
			if self.window_in_fullscreen:
				self.wndMain.unfullscreen ()
			else:
				self.wndMain.fullscreen ()
		elif event.keyval == gtk.keysyms.F7:
			if int(BlogSettings.Fontsize) >= 30:
				hildon.hildon_banner_show_information(widget, 'qgn_note_infoprint', 'Maximum font reached')
				return
			else:
				BlogSettings.Fontsize = str(int(BlogSettings.Fontsize) + 2)
				self.txtPost.modify_font(pango.FontDescription("Monospace "+BlogSettings.Fontsize))
				self.txtPostExt.modify_font(pango.FontDescription("Monospace " + BlogSettings.Fontsize))
				self.txtPostExc.modify_font(pango.FontDescription("Monospace " + BlogSettings.Fontsize))
	
		elif event.keyval == gtk.keysyms.F8:
			if int(BlogSettings.Fontsize) <= 9:
				hildon.hildon_banner_show_information(widget, 'qgn_note_infoprint', 'Minimal font reached')
				return
			else:
				BlogSettings.Fontsize = str(int(BlogSettings.Fontsize) - 2)
				self.txtPost.modify_font(pango.FontDescription("Monospace "+BlogSettings.Fontsize))
				self.txtPostExt.modify_font(pango.FontDescription("Monospace " + BlogSettings.Fontsize))
				self.txtPostExc.modify_font(pango.FontDescription("Monospace " + BlogSettings.Fontsize))

	def create_toolbar(self):
		self.toolbar = gtk.Toolbar()

		bold_img = gtk.Image()
		bold_img.set_from_file(imgdir + "bold.png")
		bold = gtk.ToolButton(bold_img, None)
		bold.set_expand(True)
		bold.connect("clicked", self.on_btnBold_clicked)
		self.toolbar.insert(bold, -1)
		
		italic_img = gtk.Image()
		italic_img.set_from_file(imgdir + "italic.png")
		italic = gtk.ToolButton(italic_img, None)
		italic.set_expand(True)
		italic.connect("clicked", self.on_btnItalic_clicked)		
		self.toolbar.insert(italic, -1)
		
		link_img = gtk.Image()
		link_img.set_from_file(imgdir + "link.png")
		link = gtk.ToolButton(link_img, None)
		link.set_expand(True)
		link.connect("clicked", self.on_btnLink_clicked)		
		self.toolbar.insert(link, -1)

		quote_img = gtk.Image()
		quote_img.set_from_file(imgdir + "quote.png")
		quote = gtk.ToolButton(quote_img, None)
		quote.set_expand(True)
		quote.connect("clicked", self.on_btnBlockQuote_clicked)		
		self.toolbar.insert(quote, -1)

		under_img = gtk.Image()
		under_img.set_from_file(imgdir + "underline.png")
		underline = gtk.ToolButton(under_img, None)
		underline.set_expand(True)
		underline.connect("clicked", self.on_btnIns_clicked)
		self.toolbar.insert(underline, -1)
		
		strike_img = gtk.Image()
		strike_img.set_from_file(imgdir + "strikethrough.png")
		strikethrough = gtk.ToolButton(strike_img, None)
		strikethrough.set_expand(True)
		strikethrough.connect("clicked", self.on_btnDel_clicked)
		self.toolbar.insert(strikethrough, -1)
		
		imgsrc_img = gtk.Image()
		imgsrc_img.set_from_file(imgdir + "image.png")
		image = gtk.ToolButton(imgsrc_img, None)
		image.set_expand(True)
		image.connect("clicked", self.on_btnImage_clicked)		
		self.toolbar.insert(image, -1)
		
		parag_img = gtk.Image()
		parag_img.set_from_file(imgdir + "paragraph.png")
		parag = gtk.ToolButton(parag_img, None)
		parag.set_expand(True)
		parag.connect("clicked", self.on_btnparag_clicked)
		self.toolbar.insert(parag, -1)
				
		more = gtk.ToolButton(gtk.STOCK_ADD)
		more.set_expand(True)
		more.connect("clicked", self.on_optwrite_clicked)
		self.toolbar.insert(more, -1)
		
		settings = gtk.ToolButton(gtk.STOCK_PREFERENCES)
		settings.set_expand(True)
		settings.connect("clicked", self.on_btnSettings_clicked)
		self.toolbar.insert(settings, -1)		
		
		delete_art = gtk.ToolButton(gtk.STOCK_DELETE)
		delete_art.set_expand(True)
		delete_art.connect("clicked", self.on_btngetarticles_clicked)
		self.toolbar.insert(delete_art, -1)			
		
		categories = gtk.ToolButton(gtk.STOCK_INDEX)
		categories.set_expand(True)
		categories.connect("clicked", self.on_btncategories_clicked)
		self.toolbar.insert(categories, -1)

		post = gtk.ToolButton(gtk.STOCK_GO_UP)
		post.set_expand(True)
		post.connect("clicked", self.on_btnpost_clicked)
		self.toolbar.insert(post, -1)

		self.wndMain.add_toolbar(self.toolbar)

	#show/hide the toolbar
	def on_view_toolbar(self, widget):
		if not self.toolbarmenu.get_active():
			self.toolbar.destroy()
			self.wndMain.show_all()
		else:
			self.create_toolbar()
			self.wndMain.show_all()

	def quit(self, widget):	
		gtk.main_quit()

	def on_help(self, widget, help):
		#Show specific help depending button clicked
		if help == 'others':		
			from help_file import others_help as help
			title = 'Others Tab Help'
		elif help == 'html_tags':
			from help_file import html_tags_help as help
			title = 'Html Tags Help'
		elif help == 'image_edition':
			from help_file import image_edition_help as help
			title = 'Image Edition Help'
		elif help == 'image_help':
			from help_file import image_help as help
			title = 'Image Help'
		elif help == 'image_html':
			from help_file import image_html_help as help
			title = 'HTML Options Help'
		elif help == 'image_flickr':
			from help_file import image_flickr_help as help
			title = 'Flickr Images Help'
		elif help == 'general':
			from help_file import general_help as help
			title = 'General Help'
		elif help == 'blogger_labels':
			from help_file import blogger_labels_help as help
			title = 'Blogger Labels Help'
		elif help == 'flickr_upload':
			from help_file import flickr_upload_help as help
			title = 'Flickr Upload Help'

		self.help_dialog(title=title, transient=self.wndMain, wsize=620, hsize=340, text=help)

	def on_file_new(self, widget):
		#show confirmation dialog
		confirmation = self.on_new_confirmation()
		if confirmation == True:
			## Clear all text, title, tags, etc.
			self.enTitle.set_text("")
			self.set_post_text("")
			self.xml_file = None
			self.en_tags.set_text("")
			self.en_track.set_text("")
			self.txtBufferExt.delete(self.txtBufferExt.get_start_iter(), self.txtBufferExt.get_end_iter())
			self.txtBufferExc.delete(self.txtBufferExc.get_start_iter(), self.txtBufferExc.get_end_iter())
		else:
			return

	def on_new_confirmation(self):
		#Confirmation dialog for new article
		dialog = gtk.MessageDialog(parent=self.wndMain, type=gtk.MESSAGE_QUESTION, buttons=gtk.BUTTONS_YES_NO, message_format='Are you sure?\nIt will delete the current entry')
		dialog.show_all()
		result = dialog.run()
		if result == -8:
			dialog.destroy()
			return True

		dialog.destroy()
		return False

	def on_file_open(self, widget):
		"""This function open an XML file"""
		xml_file = self.file_browse(gtk.FILE_CHOOSER_ACTION_OPEN)
		if (xml_file == False) or (xml_file== None):
			self.xml_file = self.xml_file
			print self.xml_file
			print 'No file selected.'
			return			

		self.xml_load_from_file(xml_file)
		self.xml_file = xml_file

	def on_file_save(self, widget):
		"""This function saves the current post as an XML file"""

		# Let the user browse for the save location and name
		if (self.xml_file == None) or (self.xml_file == False):
			self.xml_file = self.file_browse(gtk.FILE_CHOOSER_ACTION_SAVE)
		#If we have a xml_file
		if (self.xml_file):
			self.xml_save_to_file(self.xml_file)

	def xml_save_to_file(self, xml_file):
		"""Save the current post to xml_file
		@param xml_file - string - path to file that
		we will save the xml to.
		@returns boolean - True success. False failure
		"""
		#Init return value
		success = False

		#Get the available DOM Implementation
		impl = minidom.getDOMImplementation()
		#Create the document, with wordpy as to base node
		xml_document = impl.createDocument(None, self._xml_tags[MAIN_TAG], None)
		#Save the post settings into the xml
		self.xml_save(xml_document)
		#Now actually try to save the file
		try:
			save_file = open(xml_file, 'w')
			#write the xml document to disc
			xml_document.documentElement.writexml(save_file)
			save_file.close()
		except IOError, (errno, strerror):
			self.show_error_dlg(
				"Error saving post(%s): %s" % (errno, strerror))
		else:
			#Allright it all worked! Set the return value
			success = True

		return success

	def xml_load_from_file(self, xml_file):
		"""Load a post from an xml file
		@param xml_file - string - path to file that
		we will load.
		@returns boolean - True success. False failure
		"""
		#Init return value
		success = False

		#Load the xml_file to a document
		try:
			xml_document = minidom.parse(xml_file)
			if (xml_document):
				success = ((self.xml_load(xml_document)))
		except IOError, (errno, strerror):
			self.show_error_dlg(
				"Error loading post file(%s): %s" % (errno, strerror))
		except:
			self.show_error_dlg("Error loading post file.")
		return success


	def on_file_save_as(self, widget):
		"""Let the user save the current file to a new location."""

		xml_file = "Untitled"
		if (self.xml_file != None) and (self.xml_file != False):
			xml_file = os.path.basename(self.xml_file)

		xml_file = self.file_browse(gtk.FILE_CHOOSER_ACTION_SAVE, xml_file)
		#If we have a xml_file
		if (xml_file):
			if (self.xml_save_to_file(xml_file)):
				"""Allright it all worked! save the current file and
				set the title."""
				self.xml_file = xml_file


	def xml_save(self, xml_document):
		"""Save the current blog post to an xml document.
		@param xml_document - xml.dom.minidom.Document object -
		The xml document that we will save the post to."""

		#First create the "post" xml element
		post_element = xml_document.createElement(self._xml_tags[POST_TAG])  # creates <post></post>
		#Title
		title = self.enTitle.get_text()
		#Text
		start, end = self.txtBuffer.get_bounds()
		text = self.txtBuffer.get_text(start, end)
		extended_text = self.txtBufferExt.get_text(self.txtBufferExt.get_start_iter(), self.txtBufferExt.get_end_iter(), include_hidden_chars=1)
		excerpt = self.txtBufferExc.get_text(self.txtBufferExc.get_start_iter(), self.txtBufferExc.get_end_iter(), include_hidden_chars=1)
		ttags_text = self.en_tags.get_text()
		tracks_text = self.en_track.get_text()
		# creates <title></title>
		title_element = xml_document.createElement(self._xml_tags[TITLE_TAG])
		#Create <title>title text</title>
		title_element.appendChild(xml_document.createTextNode(title))
		# creates <text></text>
		text_element = xml_document.createElement(self._xml_tags[TEXT_TAG])
		# creates <text>text</text>
		text_element.appendChild(xml_document.createTextNode(text))
		#create excerpt
		excerpt_element = xml_document.createElement(self._xml_tags[EXCERPT_TAG])
		# creates <excerpt>excerpt text</excerpt>
		excerpt_element.appendChild(xml_document.createTextNode(excerpt))		
		#create extended entry
		extended_element = xml_document.createElement(self._xml_tags[EXTENDED_ENTRY_TAG])
		# creates <extended>extended text</extended>
		extended_element.appendChild(xml_document.createTextNode(extended_text))	
		#create ttags
		ttags_element = xml_document.createElement(self._xml_tags[TTAGS_TAG])		
		# creates <ttags>technorati tags</ttags>
		ttags_element.appendChild(xml_document.createTextNode(ttags_text))		
		#create trackbacks
		tracks_element = xml_document.createElement(self._xml_tags[TRACKS_TAG])		
		# creates <trackbacks>trackbacks</trackbacks>
		tracks_element.appendChild(xml_document.createTextNode(tracks_text))		
		
		#Now create <post><title>title text</title><text>text</text></post>
		post_element.appendChild(title_element)
		post_element.appendChild(text_element)
		post_element.appendChild(excerpt_element)
		post_element.appendChild(extended_element)		
		post_element.appendChild(ttags_element)
		post_element.appendChild(tracks_element)		
		
		#Now add to the xml docuemnt
		xml_document.documentElement.appendChild(post_element)

	def xml_load(self, xml_document):
		"""Load the current blog post from an xml document.
		@param xml_document - xml.dom.minidom.Document object -
		The xml document that we will load the post from.
		@returns boolean True - success.  False - Failure."""

		title_loaded = False
		text_loaded = False
		excerpt_loaded = False
		extended_loaded = False
		ttags_loaded = False
		tracks_loaded = False

		#Loop through all child nodes of the root.
		for node in xml_document.documentElement.childNodes:
			#We are looking for the post Node
			if (node.nodeName == self._xml_tags[POST_TAG]):
				# Now loop through the post nodes children
				for item_node in node.childNodes:
					if (item_node.nodeName == self._xml_tags[TITLE_TAG]):
						"""Set the title, the firstChild in this case is
						the actual title text that we saved."""

						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.enTitle.set_text(item_node.firstChild.nodeValue)
						else:
							self.enTitle.set_text("")
						title_loaded = True
					elif (item_node.nodeName == self._xml_tags[TEXT_TAG]):
						"""Set the text, the firstChild in this case is
						the actual text that we saved."""
						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.set_post_text(item_node.firstChild.nodeValue)
						else:
							self.set_post_text("")
						text_loaded = True
					elif (item_node.nodeName == self._xml_tags[EXCERPT_TAG]):
						"""Set the text, the firstChild in this case is
						the actual text that we saved."""
						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.txtBufferExc.set_text(item_node.firstChild.nodeValue)
						else:
							self.txtBufferExc.set_text("")
						excerpt_loaded = True						
					elif (item_node.nodeName == self._xml_tags[EXTENDED_ENTRY_TAG]):
						"""Set the text, the firstChild in this case is
						the actual text that we saved."""
						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.txtBufferExt.set_text(item_node.firstChild.nodeValue)
						else:
							self.txtBufferExt.set_text("")
						extended_loaded = True													
					elif (item_node.nodeName == self._xml_tags[TTAGS_TAG]):
						"""Set the text, the firstChild in this case is
						the actual text that we saved."""
						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.en_tags.set_text(item_node.firstChild.nodeValue)
						else:
							self.en_tags.set_text("")
						ttags_loaded = True							
					elif (item_node.nodeName == self._xml_tags[TRACKS_TAG]):
						"""Set the text, the firstChild in this case is
						the actual text that we saved."""
						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.en_track.set_text(item_node.firstChild.nodeValue)
						else:
							self.en_track.set_text("")
						tracks_loaded = True							
	
				#Break out of the topmost for loop
				break

		return (title_loaded and text_loaded and excerpt_loaded and extended_loaded and ttags_loaded and tracks_loaded)

	def set_post_text(self, text):
		"""Simple Helper function that sets the text
		in the text View.
		@param text - The text that will be put into
		the text view.
		"""
		#select all of the text
		start, end = self.txtBuffer.get_bounds()
		self.txtBuffer.select_range(end,start)
		#insert over the selection i.e. replace all the text
		self.insert_text(text)
		#put the selection at the end.
		start, end = self.txtBuffer.get_bounds()
		self.txtBuffer.select_range(end,end)


	# Borrowed from the PyWine project and modified for Maemo WordPy
	def file_browse(self, dialog_action, file_name=""):
		"""This function is used to browse for a file.
		It can be either a save or open dialog depending on
		what dialog_action is.
		The path to the file will be returned if the user
		selects one, however a blank string will be returned
		if they cancel or do not select one.
		dialog_action - The open or save mode for the dialog either
		gtk.FILE_CHOOSER_ACTION_OPEN, gtk.FILE_CHOOSER_ACTION_SAVE
		@param file_name - Default name when doing a save
		@returns - File Name, or False on cancel.
		"""

		if (dialog_action==gtk.FILE_CHOOSER_ACTION_OPEN):
			dlg_title = "Open Article"
		else:
			dlg_title = "Save Article"

		file_dialog = hildon.FileChooserDialog(self.wndMain, action=dialog_action)
		file_dialog.set_title(dlg_title)
		file_dialog.set_default_response(gtk.RESPONSE_CANCEL)
		"""set the filename if we are saving"""
		if (dialog_action==gtk.FILE_CHOOSER_ACTION_SAVE):
			file_dialog.set_current_name(file_name)
			file_dialog.set_current_folder('/home/user/MyDocs/.documents')
		"""Init the return value"""
		result = file_dialog.run()
		if result == gtk.RESPONSE_OK:
			namefile = file_dialog.get_filename()
			if (dialog_action==gtk.FILE_CHOOSER_ACTION_SAVE):
				namefile, extension = os.path.splitext(namefile)
				namefile = namefile + "." + FILE_EXT
		else:
			namefile = False
		file_dialog.destroy()

		return namefile

	def on_flickr_upload_clicked(self, widget):
		##Show flickr upload dialog from the menu
		FlickrUpload()

	def on_cut(self, widget):
		if self.txtPost.is_focus() == 1:
			self.txtPost.emit("cut-clipboard")
		elif self.enTitle.is_focus() == 1:
			self.enTitle.emit("cut-clipboard")
		elif self.en_track.is_focus() == 1:
			self.en_track.emit("cut-clipboard")
		elif self.en_tags.is_focus() == 1:
			self.en_tags.emit("cut-clipboard")
		elif self.txtPostExt.is_focus() == 1:
			self.txtPostExt.emit("cut-clipboard")
		elif self.txtPostExc.is_focus() == 1:
			self.txtPostExc.emit("cut-clipboard")		
		else:
			pass

	def on_copy(self, widget):
		if self.txtPost.is_focus() == 1:
			self.txtPost.emit("copy-clipboard")
		elif self.enTitle.is_focus() == 1:
			self.enTitle.emit("copy-clipboard")
		elif self.en_track.is_focus() == 1:
			self.en_track.emit("copy-clipboard")
		elif self.en_tags.is_focus() == 1:
			self.en_tags.emit("copy-clipboard")
		elif self.txtPostExt.is_focus() == 1:
			self.txtPostExt.emit("copy-clipboard")
		elif self.txtPostExc.is_focus() == 1:
			self.txtPostExc.emit("copy-clipboard")		
		else:
			pass

	def on_paste(self, widget):
		if self.txtPost.is_focus() == 1:
			self.txtPost.emit("paste-clipboard")
		elif self.enTitle.is_focus() == 1:
			self.enTitle.emit("paste-clipboard")
		elif self.en_track.is_focus() == 1:
			self.en_track.emit("paste-clipboard")
		elif self.en_tags.is_focus() == 1:
			self.en_tags.emit("paste-clipboard")
		elif self.txtPostExt.is_focus() == 1:
			self.txtPostExt.emit("paste-clipboard")
		elif self.txtPostExc.is_focus() == 1:
			self.txtPostExc.emit("paste-clipboard")			
		else:
			pass

	def on_about_credits(self, widget):
		"""Show the credits dialog."""
		dialog = gtk.AboutDialog()
		btn = gtk.Button()
		btn.set_relief(gtk.RELIEF_NONE)
		btn.set_focus_on_click(False)
		btn.set_property('visible', False)
		btn.set_property('can-focus', False)
		btn.connect('clicked', self.show_staff_dialog, dialog)
		hbox = gtk.HBox()
		lab1 = gtk.Label()
		lab2 = gtk.Label()
		hbox.pack_start(lab1, True, True, 0)
		hbox.pack_start(btn, False, False, 0)
		hbox.pack_start(lab2, True, True, 0)		
		dialog.vbox.pack_start(hbox, False, False, 0)
		dialog.set_name("Maemo WordPy")
		dialog.set_version("0.6")
		dialog.set_copyright("Copyright © 2007")
		dialog.set_website("http://maemo-wordpy.garage.maemo.org")
		dialog.set_authors(["Daniel Martín Yerga <dyerga@gmail.com> \n\nBased in WordPy by Mark Mruss"])
 		logo = gtk.gdk.pixbuf_new_from_file(imgdir + "logo.png")
		dialog.set_logo(logo)
		dialog.set_license("This program is released under the GNU\nGeneral Public License. Please visit \nhttp://www.gnu.org/copyleft/gpl.html\nfor details.")
		dialog.set_artists(["Logo by Daniel Martín Yerga.\nMenu icons from Gartoon Iconset. GPL License."])
		dialog.show_all()
		dialog.run()
		dialog.destroy()

	def show_staff_dialog(self, widget, dialog):
		self.wTree=gtk.glade.XML(glade_file)
		staff_dlg = self.wTree.get_widget("view_img_dialog")
		staff_dlg.set_title('Staff')
		staff_dlg.set_transient_for(dialog)
		staff_dlg.add_button("Close", gtk.RESPONSE_CLOSE)

		hbox = gtk.HBox()
		label = gtk.Label()
		label.set_markup("<small>Yes, you found this!\nThis is a small honoring to my cat.\nShe's beautiful, but she's the evil,\nrises on the cupboards, on the tables,\nescapes to the street to looking for cats,\nshe bites...\nBut I cannot live without her :)\n\nIn 0.7 version I will think\nsomething more funny.</small>")

		staff_img = self.wTree.get_widget("view_img")
		staff_img.set_from_file(imgdir + 'staff.jpg')

		staff_img.reparent(hbox)
		hbox.pack_start(label, True, True, 35)
		staff_dlg.vbox.pack_start(hbox, True, True, 0) 

		staff_dlg.show_all()
		staff_dlg.run()
		staff_dlg.destroy()

	def show_error_dlg(self, error_string):
		"""This Function is used to show an error dialog when
		an error occurs.
		error_string - The error string that will be displayed
		on the dialog.
		"""
		error_dlg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR, message_format=error_string, buttons=gtk.BUTTONS_OK)
		error_dlg.run()
		error_dlg.destroy()

	def on_btnBold_clicked(self, widget):
		"""Called when the bold button is clicked"""
		self.wrap_selection("<span style='font-weight: bold'>","</span>")

	def on_btnItalic_clicked(self, widget):
		"""Called when the italic button is clicked"""
		self.wrap_selection("<span style='font-style: italic'>","</span>")

	def on_btnLink_clicked(self, widget):
		"""Called when the link button is clicked"""				
		self.wTree=gtk.glade.XML(glade_file)
		##get the text selected
		start, end = self.get_selection_iters()
		link_dlg = self.wTree.get_widget("main_dialog")
		link_dlg.add_buttons('Cancel', gtk.RESPONSE_CANCEL, 'Insert', gtk.RESPONSE_OK)
		link_dlg.set_transient_for(self.wndMain)
		link_dlg.set_title("Insert Link")
		link_dlg.set_default_response(gtk.RESPONSE_CANCEL)
	
		enURL = self.wTree.get_widget("main_entry")
		enURL.set_text("http://")
		enURL.select_region(7, 7)
		link_label = self.wTree.get_widget("main_label")
		link_label.set_text("Enter the URL:")
			
		result = link_dlg.run()
		if (result == gtk.RESPONSE_OK):
			if ((start)and(end)):
				## select the selected text in the article if it lost the selection
				self.txtBuffer.select_range(end,start)
			self.wrap_selection("<a href=\"%s\">" % enURL.get_text(),"</a>")

		link_dlg.destroy()
		
	def on_btnBlockQuote_clicked(self, widget):
		"""Called when the Block Quote button is clicked"""		
		self.wrap_selection("<blockquote>","</blockquote>")

	def on_btnDel_clicked(self, widget):
		"""Called when the Del button is clicked"""
		import datetime
		today = datetime.date.today()
		self.wrap_selection('<span style="text-decoration:line-through">','</span>')

	def on_btnIns_clicked(self, widget):
		"""Called when the Ins button is clicked"""
		import datetime
		today = datetime.date.today()
		self.wrap_selection('<span style="text-decoration:underline">','</span>')

	def on_btnImage_clicked(self, widget):
		"""Called when the Image button is clicked"""
		self.wTree=gtk.glade.XML(glade_file)
		self.image_dlg = self.wTree.get_widget("img_dlg")
		self.image_dlg.add_buttons('Cancel', gtk.RESPONSE_CANCEL, 'Insert', gtk.RESPONSE_OK)
		self.image_dlg.set_transient_for(self.wndMain)
		self.image_dlg.set_title("Insert Image")
		
		img_btn = self.wTree.get_widget("img_btn")

		self.en_imgsrc = self.wTree.get_widget("en_img")
		self.en_alttext = self.wTree.get_widget("en_alttext")

		self.img_align = self.wTree.get_widget("combo_img_align")
		child_align = self.img_align.child
		child_align.set_property("editable", False)	

		self.original_button = self.wTree.get_widget("original")
		self.original_button.set_active(True)
		self.original_button.connect('toggled', self.on_original_active)
		self.resize_button = self.wTree.get_widget("resize")

		self.labelwidth_html = self.wTree.get_widget("label14")
		self.labelheight_html = self.wTree.get_widget("label15")

		self.img_width = self.wTree.get_widget("img_width")

		image_html_help_btn = self.wTree.get_widget("image_html_btn")
		image_html_help_btn.connect("clicked", self.on_help, 'image_html')

		self.img_height = self.wTree.get_widget("img_height")
		self.img_width.connect('value-changed', self.preserve_image_aspect, "width", self.img_height)
		self.img_height.connect('value-changed', self.preserve_image_aspect, "height", self.img_width)
		
		self.ratio_btn = self.wTree.get_widget("ratio_btn")
		self.ratio_btn.set_active(self.preserve_aspect)
		self.ratio_btn.connect('toggled', self.aspect_ratio_toggled, self.img_width, self.img_height)
		
		self.do_resize_widgets_insensitive()

		## Edit tab
		image1 = self.wTree.get_widget("image1")

		def get_image(widget, image):
			#Get local image
			filename = self.browse_for_image(widget, image1)
			self.image_filename = filename

		img_btn.connect("clicked", get_image, image1)

		cache_img_btn = self.wTree.get_widget("cache_img_btn")
		cache_img_btn.connect("clicked", self.on_cache_image_clicked)

		image_help_btn = self.wTree.get_widget("image_help_btn")
		image_help_btn.connect("clicked", self.on_help, 'image_help')

		if BlogSettings.System == 'Blogger' and not picasa:
			img_notebook = self.wTree.get_widget("img_notebook")
			img_btn.set_sensitive(False)
			img_notebook.remove_page(2)
		else:
			##EditImage buttons
			resize_btn = self.wTree.get_widget("resize_btn")
			resize_btn.connect("clicked", self.on_resize_clicked)
			crop_btn = self.wTree.get_widget("crop_btn")
			crop_btn.connect("clicked", self.on_crop_clicked, image1)
			flip_btn = self.wTree.get_widget("flip_btn")
			flip_btn.connect("clicked", self.on_flip_clicked, image1)
			rotate_btn = self.wTree.get_widget("rotate_btn")
			rotate_btn.connect("clicked", self.on_rotate_clicked, image1)
			screenshot_btn = self.wTree.get_widget("screenshot_btn")
			screenshot_btn.connect("clicked", self.on_screenshot_clicked, image1)
			filters_btn = self.wTree.get_widget("filters_btn")
			filters_btn.connect("clicked", self.on_filters_clicked, image1)
			options_img_button  = self.wTree.get_widget("options_img_btn")
			options_img_button.connect("clicked", self.on_options_img, image1)
			final_edit_button = self.wTree.get_widget("finalize_edit_btn")
			final_edit_button.connect("clicked", self.on_finalize_edit)
			help_button = self.wTree.get_widget("help_img_btn")
			help_button.connect("clicked", self.on_help, 'image_edition')

		######## Flickr Tab ###########		
		vbox6 = self.wTree.get_widget("vbox6")
		
		self.photoslist = gtk.ListStore(gobject.TYPE_STRING)		
		self.combophotos = gtk.ComboBoxEntry(self.photoslist, 0)
		self.combophotos.connect("changed", self.on_photolist_changed)	
		photos_entry = self.combophotos.child
		photos_entry.set_property("editable", False)
		vbox6.pack_start(self.combophotos, False, False, 0)
		vbox6.reorder_child(self.combophotos, 1)

		flickr_help_btn = self.wTree.get_widget("flickr_help_btn")
		flickr_help_btn.connect("clicked", self.on_help, 'image_flickr')

		get_flickr_btn = self.wTree.get_widget("button3")
		get_flickr_btn.connect("clicked", self.on_get_flickr_photos)
			
		self.add_flickr_btn = self.wTree.get_widget("button2")
		self.add_flickr_btn.set_sensitive(False)
		self.add_flickr_btn.connect("clicked", self.on_add_flickr_photo)
		
		vbox13 = self.wTree.get_widget("vbox13")
		
		self.sizelist = gtk.ListStore(gobject.TYPE_STRING)
		self.combosize = gtk.ComboBoxEntry(self.sizelist, 0)
		self.combosize.connect("changed", self.on_sizelist_changed)
		size_entry = self.combosize.child
		size_entry.set_property("editable", False)				
		vbox13.pack_start(self.combosize, False, False, 0)
		vbox13.reorder_child(self.combosize, 0)
		 
		self.labelWidth = self.wTree.get_widget("label22")
		self.labelHeight = self.wTree.get_widget("label33")
		
		vbox5 = self.wTree.get_widget("vbox5")		
		self.num_page = hildon.NumberEditor(1, 3000)
		self.num_page.set_value(1)
		vbox5.pack_start(self.num_page, True, True, 0)
		vbox5.reorder_child(self.num_page, 1)

		### Run dialog ###
		self.image_dlg.show_all()
		result = self.image_dlg.run()
		if (result == gtk.RESPONSE_OK):
			##If there isn't selected image, undo all
			if self.en_imgsrc.get_text() == '':
				self.image_dlg.destroy()
				self.delete_temp_images()
				del self.new_pixbuf
				self.new_pixbuf = None
				self.image_filename = None
				return
			
			## Get filename, alt text, align, etc
			self.imageURL = self.en_imgsrc.get_text()
			self.imageAlt = self.en_alttext.get_text()
			self.imageAlign = self.img_align.get_active_text()
			self.imageHeight = str(self.img_height.get_value_as_int())
			self.imageWidth = str(self.img_width.get_value_as_int()) 

			##Get the textview where to insert the image
			if self.txtPost.is_focus() == 1:
				self.txtBuffer = self.txtPost.get_buffer()
			elif self.txtPostExt.is_focus() == 1:
				self.txtBuffer = self.txtPostExt.get_buffer()
			elif self.txtPostExc.is_focus() == 1:
				self.image_dlg.destroy()
				self.show_error_dlg("You can't to add images in the excerpt.")
				return
			
			## Delete the pixbuf in image edition
			del self.new_pixbuf
			self.new_pixbuf = None

			## Start in new thread the processing
			thread.start_new_thread(self.text_img, ())		
		else:
			##If cancel image dialog, undo all
			self.delete_temp_images()
			del self.new_pixbuf
			self.new_pixbuf = None
			self.image_filename = None
		
		self.image_dlg.destroy()
		
			
	def on_original_active(self, widget):
		## If original in html size is active or not, do sensitive 
		## or insesitive widgets
		if self.original_button.get_active() == True:
			self.do_resize_widgets_insensitive()
		else:
			self.img_width.set_sensitive(True)
			self.labelwidth_html.set_sensitive(True)
			self.labelheight_html.set_sensitive(True)
			self.img_height.set_sensitive(True)
			self.ratio_btn.set_sensitive(True)	
				
	def do_resize_widgets_insensitive(self):
		## Do insensitive the html size widgets
		self.img_width.set_sensitive(False)
		self.labelwidth_html.set_sensitive(False)
		self.labelheight_html.set_sensitive(False)
		self.img_height.set_sensitive(False)
		self.ratio_btn.set_sensitive(False)	
		
	def aspect_ratio_toggled(self, togglebutton, width, height):
		## If there is local image selected, keep aspect ratio or not
		## this is in html size widgets
		try:
			self.preserve_aspect = togglebutton.get_active()
			if self.preserve_aspect:
				# Set height based on width and aspect ratio
				target_value = float(width.get_value_as_int())/self.new_pixbuf.get_width()
				target_value = int(target_value * self.new_pixbuf.get_height())
				self.ignore_preserve_aspect_callback = True
				height.set_value(target_value)
				self.ignore_preserve_aspect_callback = False
		except:
			print 'Image not selected.'
	
	def preserve_image_aspect(self, currspinbox, type, otherspinbox):
		## If there is local image selected, and keep aspect ratio active
		## in html size widgets, preserve image aspect
		try:
			if not self.preserve_aspect:
				return
			if self.ignore_preserve_aspect_callback:
				return
			if type == "width":
				target_value = float(currspinbox.get_value_as_int())/self.new_pixbuf.get_width()
				target_value = int(target_value * self.new_pixbuf.get_height())
			else:
				target_value = float(currspinbox.get_value_as_int())/self.new_pixbuf.get_height()
				target_value = int(target_value * self.new_pixbuf.get_width())
			self.ignore_preserve_aspect_callback = True
			otherspinbox.set_value(target_value)
			self.ignore_preserve_aspect_callback = False
		except:
			print 'Image not selected.'

	def text_img(self):
		## Do stuff with text to insert in image dialog
		self.image_dlg.destroy()

		if self.imageURL.find('/var/tmp/') >= 0:
			## If there is temporal edited images, copy it to maemowordpy config dir
			## and get it url, and delete the temporal image
			## When it is uploaded with an article, it will be deleted
			## TODO: it needs a simple dialog for deleting copied images that haven't 
			## been upload with an article. For example, user edit an image, and insert
			## it in the article but she doesn't upload the article never, the image
			## will be in maemowordpy config dir forever ;)
			import shutil
			temp_image_dir = '/home/user/.maemowordpy/images/'
			shutil.copy(self.imageURL.replace('file://', ''), temp_image_dir)
			filename = self.imageURL.replace('file://', '').split('/')
			self.imageURL = 'file://' + temp_image_dir + filename[len(filename)-1]
			#print self.imageURL
			self.delete_temp_images()
			del self.new_pixbuf
			self.new_pixbuf = None
			self.image_filename = None

		img_src = "<img src=\"" + self.imageURL

		## If there isn't selected image, destroy the dialog
		if self.imageURL == '':
			self.image_dlg.destroy()
			return
		## If resize html tags is active, add it to <img> tag
		if self.resize_button.get_active() == True:
			img_src = img_src + "\" width=\"" + self.imageWidth + "\" height=\"" + self.imageHeight
		## If there is alt text, add it to <img> tag		
		if self.imageAlt != '':
			img_src = img_src + "\" alt=\"" + self.imageAlt
		#final_img_src is the final <img src...> text
		final_img_src = img_src + "\" />"

		## If there is alignment setted, add it and add the <img> to the textview
		## If there isn't alignment setted, add the <img> to the textview	
		if self.imageAlign != '':
			text1 = '<div style="text-align:' +  self.imageAlign + '">'
			self.txtBuffer.insert_at_cursor(text1, -1)
			start, end = self.txtBuffer.get_bounds()
			self.txtBuffer.insert_interactive(end, final_img_src, -1)
			text2 = '</div>'
			start, end = self.txtBuffer.get_bounds()			
			self.txtBuffer.insert_interactive(end, text2, -1)
		else:
			self.txtBuffer.insert_at_cursor(final_img_src, -1)
			
		self.image_dlg.destroy()

	def on_resize_clicked(self, widget):
		## Show the resize image dialog
		if self.new_pixbuf == None:
			self.show_error_dlg("Not image selected.")
			return
		self.wTree=gtk.glade.XML(glade_file)
		resize_dlg = self.wTree.get_widget("resize_dialog")
		resize_dlg.set_transient_for(self.image_dlg)
		resize_dlg.set_title("Resize Image")
		resize_dlg.add_buttons("Resize", gtk.RESPONSE_OK, "Cancel", gtk.RESPONSE_CLOSE)

		img_height = self.wTree.get_widget("height_resize")
		img_width = self.wTree.get_widget("width_resize")
		
		try: 
			## Get width and height of the image
			img_width.set_value(int(self.new_pixbuf.get_width()))
			img_height.set_value(int(self.new_pixbuf.get_height()))	
		except:
			self.show_error_dlg("Image size can't be obtained.")

		img_width.connect('value-changed', self.preserve_image_aspect, "width", img_height)
		img_height.connect('value-changed', self.preserve_image_aspect, "height", img_width)
		
		ratio_btn = self.wTree.get_widget("check_ratio")
		ratio_btn.set_active(self.preserve_aspect)
		ratio_btn.connect('toggled', self.aspect_ratio_toggled, img_width, img_height)
		
		resize_dlg.show_all()
		result = resize_dlg.run()

		if (result == gtk.RESPONSE_OK):
			self.resize_image(img_width.get_value(), img_height.get_value())
		
		resize_dlg.destroy()
	
	def resize_image(self, w, h):
		try:
			self.new_pixbuf = self.new_pixbuf.scale_simple(int(w), int(h), gtk.gdk.INTERP_BILINEAR)
		except:
			print "new-pixbuf doesn't exist."

	### All crop functions are from Mirage Image viewer code  ####
	### http://mirageiv.berlios.de
	### with some changes for maemo wordpy					  ####		
	def on_crop_clicked(self, widget, gtkimage):
		if self.new_pixbuf == None:
			self.show_error_dlg("Not image selected.")
			return
			
		self.wTree=gtk.glade.XML(glade_file)
		crop_dlg = self.wTree.get_widget("crop_dialog")
		crop_dlg.set_transient_for(self.wndMain)
		crop_dlg.set_title("Crop Image")
		crop_dlg.add_buttons("Crop", gtk.RESPONSE_OK, "Cancel", gtk.RESPONSE_CLOSE)

		dra1 = self.wTree.get_widget("drawingarea1")

		image_width, image_height = self.set_thumbnail_size(self.new_pixbuf, False)
		dra1.set_size_request(int(image_width), int(image_height))		
		crop_pixbuf = self.new_pixbuf.scale_simple(int(image_width), int(image_height), gtk.gdk.INTERP_BILINEAR)
				
		x_spin = self.wTree.get_widget("x_spin")
		width_spin = self.wTree.get_widget("width_spin")
		
		x_adj = gtk.Adjustment(0, 0, self.new_pixbuf.get_width(), 1, 10, 10)
		x_spin.set_adjustment(x_adj)
		
		width_adj = gtk.Adjustment(self.new_pixbuf.get_width(), 1, self.new_pixbuf.get_width(), 1, 10, 10)
		width_spin.set_adjustment(width_adj)
		
		y_spin = self.wTree.get_widget("y_spin")
		height_spin =self.wTree.get_widget("height_spin")
		
		y_adj = gtk.Adjustment(0, 0, self.new_pixbuf.get_height(), 1, 10, 10)
		y_spin.set_adjustment(y_adj)
		
		height_adj = gtk.Adjustment(self.new_pixbuf.get_height(), 1, self.new_pixbuf.get_height(), 1, 10, 10)
		height_spin.set_adjustment(height_adj)
		
		try:
			width_spin.set_value(int(self.new_pixbuf.get_width()))
			height_spin.set_value(int(self.new_pixbuf.get_height()))
		except:
			print "Image size can't be obtained."
		
		dra1.set_events(gtk.gdk.POINTER_MOTION_MASK | gtk.gdk.POINTER_MOTION_HINT_MASK | gtk.gdk.BUTTON_PRESS_MASK | gtk.gdk.BUTTON_MOTION_MASK | gtk.gdk.BUTTON_RELEASE_MASK)

		dra1.connect("expose-event", self.crop_image_expose_cb, crop_pixbuf, image_width, image_height)
		dra1.connect("motion_notify_event", self.crop_image_mouse_moved, dra1, 0, 0, x_spin, y_spin, width_spin, height_spin, image_width, image_height, width_adj, height_adj)
		dra1.connect("button_press_event", self.crop_image_button_press, dra1)
		dra1.connect("button_release_event", self.crop_image_button_release)
		
		self.x_changed = x_spin.connect('value-changed', self.crop_value_changed, x_spin, y_spin, width_spin, height_spin, width_adj, height_adj, image_width, image_height, dra1, 0)
		
		self.y_changed = y_spin.connect('value-changed', self.crop_value_changed, x_spin, y_spin, width_spin, height_spin, width_adj, height_adj, image_width, image_height, dra1, 1)
		
		self.width_changed = width_spin.connect('value-changed', self.crop_value_changed, x_spin, y_spin, width_spin, height_spin, width_adj, height_adj, image_width, image_height, dra1, 2)
		
		self.height_changed = height_spin.connect('value-changed', self.crop_value_changed, x_spin, y_spin, width_spin, height_spin, width_adj, height_adj, image_width, image_height, dra1, 3)
		
		dra1.realize()
		self.crop_rectangle = [0, 0]
		self.drawing_crop_rectangle = False
		self.update_rectangle = False
		self.rect = None
		
		crop_dlg.show_all()
		
		response = crop_dlg.run()
		if (response == gtk.RESPONSE_OK):
			if self.rect != None:
				temp_pixbuf = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB, self.new_pixbuf.get_has_alpha(), 8, self.coords[2], self.coords[3])
				self.new_pixbuf.copy_area(self.coords[0], self.coords[1], self.coords[2], self.coords[3], temp_pixbuf, 0, 0)
				self.new_pixbuf = temp_pixbuf
				del temp_pixbuf

				w, h = self.set_thumbnail_size(self.new_pixbuf, False)

				scale_pix = self.new_pixbuf.scale_simple(int(w), int(h), gtk.gdk.INTERP_BILINEAR)
				gtkimage.set_from_pixbuf(scale_pix)
				gtkimage.show()
				del scale_pix

			crop_dlg.destroy()
		else:
			crop_dlg.destroy()

		crop_dlg.destroy()

	def crop_value_changed(self, currspinbox, x, y, width, height, width_adj, height_adj, image_width, image_height, image, type):
		if type == 0:   # X
			if x.get_value() + width.get_value() > self.new_pixbuf.get_width():
				width.handler_block(self.width_changed)
				width.set_value(self.new_pixbuf.get_width() - x.get_value())
				width.handler_unblock(self.width_changed)
		elif type == 1: # Y
			if y.get_value() + height.get_value() > self.new_pixbuf.get_height():
				height.handler_block(self.height_changed)
				height.set_value(self.new_pixbuf.get_height() - y.get_value())
				height.handler_unblock(self.height_changed)
		self.coords = [int(x.get_value()), int(y.get_value()), int(width.get_value()), int(height.get_value())]
		self.crop_rectangle[0] = int(round(float(self.coords[0])/self.new_pixbuf.get_width()*image_width, 0))
		self.crop_rectangle[1] = int(round(float(self.coords[1])/self.new_pixbuf.get_height()*image_height, 0))
		x2 = int(round(float(self.coords[2])/self.new_pixbuf.get_width()*image_width, 0)) + self.crop_rectangle[0]
		y2 = int(round(float(self.coords[3])/self.new_pixbuf.get_height()*image_height, 0)) + self.crop_rectangle[1]
		self.drawing_crop_rectangle = True
		self.update_rectangle = True
		self.crop_image_mouse_moved(None, None, image, x2, y2, x, y, width, height, image_width, image_height, width_adj, height_adj)
		self.update_rectangle = False
		self.drawing_crop_rectangle = False

	def crop_image_expose_cb(self, image, event, pixbuf, width, height):
		image.window.draw_pixbuf(None, pixbuf, 0, 0, 0, 0, int(width), int(height))

	def crop_image_mouse_moved(self, widget, event, image, x2, y2, x, y, width, height, image_width, image_height, width_adj, height_adj):
		if event != None:
			x2, y2, state = event.window.get_pointer()
		if self.drawing_crop_rectangle:
			if self.crop_rectangle != None or self.update_rectangle:
				gc1 = image.window.new_gc(function=gtk.gdk.INVERT)
				if self.rect != None:
					# Get rid of the previous drawn rectangle:
					image.window.draw_rectangle(gc1, False, self.rect[0], self.rect[1], self.rect[2], self.rect[3])
				self.rect = [0, 0, 0, 0]
				if self.crop_rectangle[0] > x2:
					self.rect[0] = x2
					self.rect[2] = self.crop_rectangle[0]-x2
				else:
					self.rect[0] = self.crop_rectangle[0]
					self.rect[2] = x2-self.crop_rectangle[0]
				if self.crop_rectangle[1] > y2:
					self.rect[1] = y2
					self.rect[3] = self.crop_rectangle[1]-y2
				else:
					self.rect[1] = self.crop_rectangle[1]
					self.rect[3] = y2-self.crop_rectangle[1]
				image.window.draw_rectangle(gc1, False, self.rect[0], self.rect[1], self.rect[2], self.rect[3])
				# Convert the rectangle coordinates of the current image
				# to coordinates of pixbuf_original
				if self.rect[0] < 0:
					self.rect[2] = self.rect[2] + self.rect[0]
					self.rect[0] = 0
				if self.rect[1] < 0:
					self.rect[3] = self.rect[3] + self.rect[1]
					self.rect[1] = 0
				if event != None:
					self.coords = [0,0,0,0]
					self.coords[0] = int(round(float(self.rect[0])/image_width*self.new_pixbuf.get_width(), 0))
					self.coords[1] = int(round(float(self.rect[1])/image_height*self.new_pixbuf.get_height(), 0))
					self.coords[2] = int(round(float(self.rect[2])/image_width*self.new_pixbuf.get_width(), 0))
					self.coords[3] = int(round(float(self.rect[3])/image_height*self.new_pixbuf.get_height(), 0))
					if self.coords[0] + self.coords[2] > self.new_pixbuf.get_width():
						self.coords[2] = self.new_pixbuf.get_width() - self.coords[0]
					if self.coords[1] + self.coords[3] > self.new_pixbuf.get_height():
						self.coords[3] = self.new_pixbuf.get_height() - self.coords[1]
				x.handler_block(self.x_changed)
				y.handler_block(self.y_changed)
				width.handler_block(self.width_changed)
				height.handler_block(self.height_changed)
				x.set_value(self.coords[0])
				y.set_value(self.coords[1])
				width.set_value(self.coords[2])
				height.set_value(self.coords[3])
				x.handler_unblock(self.x_changed)
				y.handler_unblock(self.y_changed)
				width_adj.set_property('upper', self.new_pixbuf.get_width() - self.coords[0])
				height_adj.set_property('upper', self.new_pixbuf.get_height() - self.coords[1])
				width.handler_unblock(self.width_changed)
				height.handler_unblock(self.height_changed)

	def crop_image_button_press(self, widget, event, image):
		x, y, state = event.window.get_pointer()
		if (state & gtk.gdk.BUTTON1_MASK):
			self.drawing_crop_rectangle = True
			self.crop_rectangle = [x, y]
			gc1 = image.window.new_gc(function=gtk.gdk.INVERT)
			if self.rect != None:
				# Get rid of the previous drawn rectangle:
				image.window.draw_rectangle(gc1, False, self.rect[0], self.rect[1], self.rect[2], self.rect[3])
				self.rect = None

	def crop_image_button_release(self, widget, event):
		x, y, state = event.window.get_pointer()
		if not (state & gtk.gdk.BUTTON1_MASK):
			self.drawing_crop_rectangle = False

		
	def on_rotate_clicked(self, widget, gtkimage):
		rotateMenu = gtk.Menu()
		leftMenu = gtk.ImageMenuItem('Rotate Left')
		leftMenu.set_size_request(-1, 55)
		leftMenu.connect('activate', self.image_rotate, 90, gtkimage)
		rightMenu = gtk.ImageMenuItem('Rotate Right')
		rightMenu.set_size_request(-1, 55)
		rightMenu.connect('activate', self.image_rotate, 270, gtkimage)
		angleMenu = gtk.ImageMenuItem('Rotate with angle')
		angleMenu.set_size_request(-1, 55)
		angleMenu.connect('activate', self.set_angle_rotate, gtkimage)
					
		rotateMenu.add(leftMenu)
		rotateMenu.add(rightMenu)
		rotateMenu.add(angleMenu)

		rotateMenu.show_all()
		rotateMenu.popup(None, None, None, 1, 0)	

	def set_angle_rotate(self, widget, gtkimage):
		angle_dlg = gtk.Dialog(title='Set Angle', parent=None, flags=gtk.WIN_POS_CENTER, buttons=("Rotate", gtk.RESPONSE_OK, "Cancel", gtk.RESPONSE_CLOSE))
		
		angle_editor = hildon.NumberEditor(0, 360)
		angle_editor.set_value(0)

		angle_dlg.vbox.pack_start(angle_editor, True, True, 0)	
	
		angle_dlg.show_all()
		
		result = angle_dlg.run()
		if (result == gtk.RESPONSE_OK):
			angle = angle_editor.get_value()
			angle_dlg.destroy()
			self.image_rotate(widget, angle, gtkimage)
		angle_dlg.destroy()

	def image_rotate(self, widget, angle, gtkimage):
		if self.new_pixbuf == None:
			self.show_error_dlg("Not image selected.")
			return
		try:
			try:
				im = self.pixbuf2Image(self.new_pixbuf)
				self.new_im = im.rotate(angle)
			except:
				self.show_error_dlg('Error converting pixbuf to PIL Image.\nPlease report this to the author.\n<dyerga@gmail.com>')
				return
		
			self.new_pixbuf = self.image2pixbuf(self.new_im)
			##Delete the first PIL image and the edited one
			del self.new_im
			del im
			
			#Get size for thumbnail
			w, h = self.set_thumbnail_size(self.new_pixbuf, False)

			scale_pix = self.new_pixbuf.scale_simple(int(w), int(h), gtk.gdk.INTERP_BILINEAR)
			gtkimage.set_from_pixbuf(scale_pix)
			gtkimage.show()
			##delete scale_pix for free memory
			del scale_pix
		except:
			self.show_error_dlg("An error occurred, image can't be rotated.")
		
	def on_flip_clicked(self, widget, gtkimage):
		import Image
		flipMenu = gtk.Menu()
		vertMenu = gtk.ImageMenuItem('Flip Vertically')
		vertMenu.set_size_request(-1, 55)
		vertMenu.connect('activate', self.image_flip, Image.FLIP_TOP_BOTTOM, gtkimage)
		horMenu = gtk.ImageMenuItem('Flip Horizontally')
		horMenu.set_size_request(-1, 55)
		horMenu.connect('activate', self.image_flip, Image.FLIP_LEFT_RIGHT, gtkimage)
					
		flipMenu.add(vertMenu)
		flipMenu.add(horMenu)

		flipMenu.show_all()
		# parent_menu_shell, parent_menu_item, func, button, activate_time, data=None
		flipMenu.popup(None, None, None, 1, 0)	

	def image_flip(self, widget, flip, gtkimage):
		if self.new_pixbuf == None:
			self.show_error_dlg("Not image selected.")
			return
		try:
			try:
				im = self.pixbuf2Image(self.new_pixbuf)
				self.new_im = im.transpose(flip)
			except:
				self.show_error_dlg('Error converting pixbuf to PIL Image.\nPlease report this to the author.\n<dyerga@gmail.com>')
				return

			self.new_pixbuf = self.image2pixbuf(self.new_im)
			del self.new_im
			del im

			w, h = self.set_thumbnail_size(self.new_pixbuf, False)

			scale_pix = self.new_pixbuf.scale_simple(int(w), int(h), gtk.gdk.INTERP_BILINEAR)
			gtkimage.set_from_pixbuf(scale_pix)
			gtkimage.show()
			del scale_pix
		except:
			self.show_error_dlg("An error occurred, image can't be flipped.")
		
	def image2pixbuf(self, im): 
		## Convert PIL Image to gtk.Pixbuf
		import StringIO
		file1 = StringIO.StringIO()  
		im.save(file1, "ppm")  
		contents = file1.getvalue()  
		file1.close()
		loader = gtk.gdk.PixbufLoader("pnm")
		loader.write(contents, len(contents))  
		pixbuf = loader.get_pixbuf()  
		loader.close()  
		return pixbuf  

	def pixbuf2Image(self, pixbuf):
		## Convert gtk.Pixbuf to PIL Image
		import Image
		assert(pixbuf.get_colorspace() == gtk.gdk.COLORSPACE_RGB)
		dimensions = pixbuf.get_width(), pixbuf.get_height()
		stride = pixbuf.get_rowstride()
		pixels = pixbuf.get_pixels()
		mode = pixbuf.get_has_alpha() and "RGBA" or "RGB"

		return Image.frombuffer(mode, dimensions, pixels, "raw", mode, stride, 1)

	def set_thumbnail_size(self, pixbuf, large_img):
		pix_width = pixbuf.get_width()
		pix_height = pixbuf.get_height()
		
		##Calculate thumbnail size for vertical and horizontal images
		##large_img for preview image dialog
		##else: preview mini
		if large_img:
			if pix_width > pix_height:
				w = 400
				h = float(pix_height)/float(pix_width) * 400
			elif pix_height > pix_width:
				h = 300
				w = float(pix_width)/float(pix_height) * 300
			elif pix_height == pix_width:
				h = 300
				w = 300
			else:
				print "Pixbuf size can't be calculated."		
				
		else:
			if pix_width > pix_height:
				w = 140
				h = float(pix_height)/float(pix_width) * 140
			elif pix_height > pix_width:
				h = 140
				w = float(pix_width)/float(pix_height) * 140
			elif pix_height == pix_width:
				h = 140
				w = 140
			else:
				print "Pixbuf size can't be calculated."

		return w, h

	def on_screenshot_clicked(self, widget, gtkimage):
		dialog = gtk.Dialog(title="Screenshot", parent=None, buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT))
		dialog.set_transient_for(self.image_dlg)
		snapbutton = dialog.add_button("Snap", gtk.RESPONSE_ACCEPT)
		snapimage = gtk.Image()
		snapimage.set_from_stock(gtk.STOCK_OK, gtk.ICON_SIZE_BUTTON)
		snapbutton.set_image(snapimage)

		vbox1 = gtk.VBox()	
		
		de = gtk.Label()
		de.set_markup('<b>' + "Delay" + '</b>')
		de.set_alignment(0, 0)

		vbox1.pack_start(de, False, False, 0)

		hbox1 = gtk.HBox()
		
		delay = hildon.NumberEditor(0, 120)
		delay.set_value(self.screenshot_delay)

		hbox1.pack_start(delay, True, True, 0)

		delaylabel = gtk.Label("seconds")
		
		hbox1.pack_start(delaylabel, False, False, 0)

		vbox1.pack_start(hbox1, False, False, 0)

		dialog.vbox.pack_start(vbox1)
		
		dialog.set_default_response(gtk.RESPONSE_ACCEPT)
		dialog.vbox.show_all()
		
		response = dialog.run()
		
		if response == gtk.RESPONSE_ACCEPT:
			while gtk.events_pending():
				gtk.main_iteration()
			self.screenshot_delay = int(delay.get_value())
			gobject.timeout_add(self.screenshot_delay*1000, self._screenshot_grab, gtkimage)
			dialog.destroy()
		else:
			dialog.destroy()
	
	def _screenshot_grab(self, gtkimage):
		root_win = gtk.gdk.get_default_root_window()
		x = 0
		y = 0
		width = gtk.gdk.screen_width()
		height = gtk.gdk.screen_height()
		pix = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB, True, 8, width, height)
		pix = pix.get_from_drawable(root_win, gtk.gdk.colormap_get_system(), x, y, 0, 0, width, height)
		
		tmpfile = self.create_temp_image(pix, "maemowordpy-", "screenshot.png")
		del pix
		# Load file:		
		self.image_filename = tmpfile
		self.new_pixbuf = gtk.gdk.pixbuf_new_from_file(tmpfile)
		w, h = self.set_thumbnail_size(self.new_pixbuf, False)
		image_pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(tmpfile, int(w), int(h))
		
		self.en_imgsrc.set_text("file://" + str(self.image_filename))
		self.en_alttext.set_text("")
		
		self.img_width.set_value(int(self.new_pixbuf.get_width()))
		self.img_height.set_value(int(self.new_pixbuf.get_height()))
		
		gtkimage.set_from_pixbuf(image_pixbuf)
		gtkimage.show()
		del image_pixbuf

	def on_options_img(self, widget, gtkimage):
		optionsMenu = gtk.Menu()
		
		refreshMenu = gtk.ImageMenuItem('Refresh Image')
		refreshMenu.set_size_request(-1, 55)
		refreshMenu.connect('activate', self.on_refresh_img, gtkimage)
		
		saveMenu = gtk.ImageMenuItem('Save Image')
		saveMenu.set_size_request(-1, 55)
		saveMenu.connect('activate', self.on_save_img)
		
		viewMenu = gtk.ImageMenuItem('Preview Image')
		viewMenu.set_size_request(-1, 55)
		viewMenu.connect('activate', self.on_preview_img)	
		
		optionsMenu.add(viewMenu)
		optionsMenu.add(saveMenu)
		optionsMenu.add(refreshMenu)

		optionsMenu.show_all()
		optionsMenu.popup(None, None, None, 1, 0)	
		
	def on_finalize_edit(self, widget):
		if self.new_pixbuf == None:
			self.show_error_dlg("Not image selected.")
			return
	
		try:
			filename = self.set_image_filename()
			if not filename:
				print "Image don't saved"
				return
			banner = hildon.hildon_banner_show_animation(widget, 'qgn_indi_pball_a', 'Creating temp file')
			banner.show()
			thread.start_new_thread(self.do_tmp_image, (banner,filename))
		except:
			print "An undetermined error occurred."

	def do_tmp_image(self, banner, filename):
		gtk.gdk.threads_enter()
		tmpfile = self.create_temp_image(self.new_pixbuf, "maemowordpy-", filename)
		gtk.gdk.threads_leave()

		thread.start_new_thread(self.do_gui_stuff, (banner,tmpfile))

	def do_gui_stuff(self, banner, tmpfile):
		self.image_filename = tmpfile
		self.new_pixbuf = gtk.gdk.pixbuf_new_from_file(tmpfile)

		self.en_imgsrc.set_text("file://" + str(self.image_filename))
		self.en_alttext.set_text("")

		self.img_width.set_value(int(self.new_pixbuf.get_width()))
		self.img_height.set_value(int(self.new_pixbuf.get_height()))

		banner.destroy()

	def set_image_filename(self):
		self.wTree=gtk.glade.XML(glade_file)
		filename_dialog = self.wTree.get_widget("filename_img_dlg")
		filename_dialog.set_transient_for(self.image_dlg)
		filename_dialog.set_title('Set filename')
		filename_dialog.add_buttons("Set", gtk.RESPONSE_OK, "Cancel", gtk.RESPONSE_CLOSE)
		
		filename_img_entry = self.wTree.get_widget("filename_img_entry")
		
		filename_dialog.show_all()
		result = filename_dialog.run()
		
		if (result==gtk.RESPONSE_OK):
			filename = filename_img_entry.get_text()
		else:
			filename = False
			
		filename_dialog.destroy()
		
		return filename

	def create_temp_image(self, pix, prefix, filename):
		# Save as /tmp/maemowordpy-<random>/filename.png
		## TODO: free space ##
		import tempfile
		tmpdir = tempfile.mkdtemp(prefix=prefix) + "/"
		tmpfile = tmpdir + filename
		pix.save(tmpfile, 'png')
		
		return tmpfile

	def delete_temp_images(self):
		## Delete temporal edited images ##
		for i in os.listdir("/var/tmp"):
			if i.find("maemowordpy") >= 0:
				import shutil
				try:
					print 'Deleting temp directory: ', i
					shutil.rmtree("/var/tmp/" + i)
				except:
					print "Temp files can't deleted."

		
	def on_filters_clicked(self, widget, gtkimage):
		filtersMenu = gtk.Menu()
		
		invertMenu = gtk.ImageMenuItem('Invert')
		invertMenu.set_size_request(-1, 55)
		invertMenu.connect('activate', self.on_invert_or_contour, gtkimage, 'invert')
		contourMenu = gtk.ImageMenuItem('Contour')
		contourMenu.set_size_request(-1, 55)
		contourMenu.connect('activate', self.on_invert_or_contour, gtkimage, 'contour')
		colorMenu = gtk.ImageMenuItem('Color')
		colorMenu.set_size_request(-1, 55)
		colorMenu.connect('activate', self.show_color_or_brightness_dlg, 'color', gtkimage)
		brigMenu = gtk.ImageMenuItem('Brightness')
		brigMenu.set_size_request(-1, 55)
		brigMenu.connect('activate', self.show_color_or_brightness_dlg, 'brightness', gtkimage)		
				
		filtersMenu.add(invertMenu)
		filtersMenu.add(contourMenu)
		filtersMenu.add(colorMenu)
		filtersMenu.add(brigMenu)				

		filtersMenu.show_all()
		filtersMenu.popup(None, None, None, 1, 0)	


	def show_color_or_brightness_dlg(self, widget, option, gtkimage):
		if self.new_pixbuf == None:
			self.show_error_dlg("Not image selected.")
			return	
		if option == 'color':
			title = "Colorize"
		elif option == 'brightness':
			title = "Set Brightness"
			
		dialog = gtk.Dialog(title=title, parent=None, flags=0, buttons=('Set', gtk.RESPONSE_OK, 'Cancel', gtk.RESPONSE_CLOSE))
		dialog.set_transient_for(self.image_dlg)

		controlbar = hildon.Controlbar()
		controlbar.set_min(0)
		controlbar.set_max(20)
		controlbar.set_value(5)

		dialog.vbox.pack_start(controlbar, False, False, 0)

		dialog.show_all()
		result = dialog.run()
		if result == gtk.RESPONSE_OK:
			valor = controlbar.get_value()/5.0
			self.on_color_or_brig_img(widget, option, valor, gtkimage)
		dialog.destroy()

	def on_color_or_brig_img(self, widget, option, valor, gtkimage):
		try:
			try:
				im = self.pixbuf2Image(self.new_pixbuf)
				import ImageEnhance
				if option == 'color':
					enh = ImageEnhance.Color(im)
					self.new_im = enh.enhance(valor)
				elif option == 'brightness':
					enh = ImageEnhance.Brightness(im)
					self.new_im = enh.enhance(valor)
			except:
				self.show_error_dlg('Error converting pixbuf to PIL Image.\nPlease report this to the author.\n<dyerga@gmail.com>')
				return

			self.new_pixbuf = self.image2pixbuf(self.new_im)
			del self.new_im
			del enh
			del im
			w, h = self.set_thumbnail_size(self.new_pixbuf, False)

			scale_pix = self.new_pixbuf.scale_simple(int(w), int(h), gtk.gdk.INTERP_BILINEAR)
			gtkimage.set_from_pixbuf(scale_pix)
			gtkimage.show()
			del scale_pix
		except:
			self.show_error_dlg("An error occured, image can't be inverted.")	

	def on_invert_or_contour(self, widget, gtkimage, option):
		if self.new_pixbuf == None:
			self.show_error_dlg("Not image selected.")
			return
		try:
			try:
				if option == 'invert':
					import ImageChops
					im = self.pixbuf2Image(self.new_pixbuf)
					self.new_im = ImageChops.invert(im)
				elif option == 'contour':
					import ImageFilter
					im = self.pixbuf2Image(self.new_pixbuf)
					self.new_im = im.filter(ImageFilter.CONTOUR)
			except:
				self.show_error_dlg('Error converting pixbuf to PIL Image.\nPlease report this to the author.\n<dyerga@gmail.com>')

			self.new_pixbuf = self.image2pixbuf(self.new_im)
			del self.new_im
			del im
			w, h = self.set_thumbnail_size(self.new_pixbuf, False)

			scale_pix = self.new_pixbuf.scale_simple(int(w), int(h), gtk.gdk.INTERP_BILINEAR)
			gtkimage.set_from_pixbuf(scale_pix)
			gtkimage.show()
			del scale_pix
		except:
			self.show_error_dlg("An error occured, image can't be edited.")


	def on_refresh_img(self, widget, gtkimage):
		try:
			self.new_pixbuf = gtk.gdk.pixbuf_new_from_file(self.image_filename)
			self.img_width.set_value(self.new_pixbuf.get_width())
			self.img_height.set_value(self.new_pixbuf.get_height())
			
			w, h = self.set_thumbnail_size(self.new_pixbuf, False)

			scale_pix = self.new_pixbuf.scale_simple(int(w), int(h), gtk.gdk.INTERP_BILINEAR)
		
			gtkimage.set_from_pixbuf(scale_pix)
			gtkimage.show()
			del scale_pix
		except:
			self.show_error_dlg("Error refreshing image.")
			gtkimage.set_from_stock(gtk.STOCK_MISSING_IMAGE, gtk.ICON_SIZE_LARGE_TOOLBAR)
			gtkimage.show()
			
	def on_save_img(self, widget):
		if self.new_pixbuf == None:
			self.show_error_dlg("Not image selected.")
			return		
		img_save_dlg = hildon.FileChooserDialog(self.wndMain, gtk.FILE_CHOOSER_ACTION_SAVE)
		img_save_dlg.set_title("Save Image as PNG")
		img_save_dlg.set_transient_for(self.image_dlg)
		img_save_dlg.set_current_folder('/home/user/MyDocs/.images')

		img_save_dlg.set_default_response(gtk.RESPONSE_OK)

		result = ""
		if img_save_dlg.run() == gtk.RESPONSE_OK:
			filename = img_save_dlg.get_filename()
			if filename.find(".png") >= 0:
				filename = filename
			else:
				filename = filename + '.png'
			self.new_pixbuf.save(filename, "png")
			
		img_save_dlg.destroy()

	def on_preview_img(self, widget):
		if self.new_pixbuf == None:
			self.show_error_dlg("Not image selected.")
			return	
		self.wTree=gtk.glade.XML(glade_file)
		preview_image_dlg = self.wTree.get_widget("view_img_dialog")
		preview_image_dlg.set_title('Preview image')
		preview_image_dlg.set_transient_for(self.image_dlg)
		preview_image_dlg.add_button("Close", gtk.RESPONSE_CLOSE)
		
		preview_img = self.wTree.get_widget("view_img")
		
		w, h = self.set_thumbnail_size(self.new_pixbuf, True)

		scale_pix = self.new_pixbuf.scale_simple(int(w), int(h), gtk.gdk.INTERP_BILINEAR)
		
		preview_img.set_from_pixbuf(scale_pix)
		preview_image_dlg.show_all()

		del scale_pix

		preview_image_dlg.run()
		preview_image_dlg.destroy()

	##### Get Flickr photos #####
	def on_get_flickr_photos(self, widget):	
		banner = hildon.hildon_banner_show_animation(widget, 'qgn_indi_pball_a', 'Getting Flickr photos')
		thread.start_new_thread(self.on_get_photos_trat, (widget, banner))

	def on_get_photos_trat(self, widget, banner):
		self.add_flickr_btn.set_sensitive(True)
		del photo_size[:]
		one_size = []
		one_width = []
		one_height = []
		one_source = []
		del all_source[:]
		del photos[:]
		self.photoslist.clear()
		self.sizelist.clear()
		del width_size[:]
		del height_size[:]
		try:
			## Get photolist in flickr ##
			lista = flickr.photos_search(api_key=api_key, user_id='me', per_page=int(BlogSettings.Flickr_num), page=self.num_page.get_value())
		except flickrapi.FlickrError, e:
			banner.destroy()
			gtk.gdk.threads_enter()
			app.show_error_dlg("Flickr error: %s\nNice error eh?" % e)
			gtk.gdk.threads_leave()	
			return
		except:	
			gtk.gdk.threads_enter()
			banner.destroy()
			gtk.gdk.threads_leave()	
			gtk.gdk.threads_enter()
			app.show_error_dlg("Error getting Flickr image list.\nDo you have an internet connection?")
			gtk.gdk.threads_leave()
			return

		## try get more pages than there is
		if int(lista.photos[0]['pages']) < int(self.num_page.get_value()):
			banner.destroy()
			gtk.gdk.threads_enter()
			self.show_error_dlg("Error: There aren't so many pages.")
			gtk.gdk.threads_leave()
			return
		## try get more photos than there is, change perpage variable
		if int(lista.photos[0]['page'])*int(BlogSettings.Flickr_num) > int(lista.photos[0]['total']):
			perpage = int(lista.photos[0]['total']) - ((int(lista.photos[0]['page'])-1)*int(BlogSettings.Flickr_num))
		else:
			perpage = int(BlogSettings.Flickr_num)
		for i in range(perpage):
			del one_size[:]
			del one_width[:]
			del one_height[:]
			del one_source[:]			
			photos.append(lista.photos[0].photo[i]['title'])
			data = flickr.photos_getSizes(api_key=api_key, photo_id=lista.photos[0].photo[i]['id'])
			for psize in data.sizes[0].size:
				one_size.append(psize['label'])
				one_width.append(psize['width'])
				one_height.append(psize['height'])
				one_source.append(psize['source'])
			photo_size.append(tuple(one_size))
			width_size.append(tuple(one_width))			
			height_size.append(tuple(one_height))
			all_source.append(tuple(one_source))
		for item in photos:
			self.photoslist.append((item,))	
		self.combophotos.set_active(0)
		
		for item in photo_size[0]:
			self.sizelist.append((item,))			
		self.combosize.set_active(0)

		self.labelWidth.set_text('Width: ' + str(width_size[0][0]))
		self.labelHeight.set_text('Height: ' + str(height_size[0][0]))
		
		banner.destroy()
		self.combophotos.show()
		self.combosize.show()		
		
	def on_sizelist_changed(self, widget):
		size_active = int(self.combosize.get_active())
		photo_active = int(self.combophotos.get_active())
		self.labelWidth.set_text('Width: ' + str(width_size[photo_active][size_active]))		 
		self.labelHeight.set_text('Height: ' + str(height_size[photo_active][size_active]))

	def on_photolist_changed(self, widget):
		photo_active = int(self.combophotos.get_active())
		size_active = int(self.combosize.get_active())
		self.labelWidth.set_text('Width: ' + str(width_size[photo_active][size_active])) 
		self.labelHeight.set_text('Height: ' + str(height_size[photo_active][size_active]))

	def on_add_flickr_photo(self, widget):
		photo = self.combophotos.get_active()
		size  = self.combosize.get_active()
		self.en_imgsrc.set_text(all_source[int(photo)][int(size)])

	def on_cache_image_clicked(self, widget):
		result = gtk.RESPONSE_CANCEL
	
		cache_img_dlg = gtk.Dialog(title='Cached Images', parent=None, flags=gtk.DIALOG_MODAL | gtk.WIN_POS_CENTER, buttons=("Delete", gtk.RESPONSE_OK, "Cancel", gtk.RESPONSE_CANCEL))
		cache_img_dlg.set_transient_for(self.wndMain)
		cache_img_dlg.set_default_size(300, 250)

		vbox1 = gtk.VBox(False, 8)

		sw = gtk.ScrolledWindow()
		if distro == 'chinook':
			if BlogSettings.Fingermenu == 'True':
				hildon.hildon_helper_set_thumb_scrollbar(sw, True)
		sw.set_shadow_type(gtk.SHADOW_ETCHED_IN)
		sw.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
		vbox1.pack_start(sw)

		del cached_images_to_delete[:]
		del cached_images[:]

		self.GetCacheImages()	

		if cached_images == []:
			self.show_error_dlg("There isn't cached images.")
			return
		model = self.cache_images_model()

		treeview = gtk.TreeView(model)
		treeview.set_rules_hint(True)
		if distro == 'chinook':
			pass
		else:
			treeview.set_property("allow-checkbox-mode", False)
		treeview.set_search_column(COLUMN_DESCRIPTION)

		sw.add(treeview)

		self.__add_columns_cache_images(treeview)
		cache_img_dlg.vbox.pack_start(vbox1, True, True, 0)
		cache_img_dlg.show_all()
		
		result = cache_img_dlg.run()
		
		if (result==gtk.RESPONSE_OK):
			try:
				for image in cached_images_to_delete:
					os.remove('/home/user/.maemowordpy/images/' + image)
				cache_img_dlg.destroy()
			except:
				self.show_error_dlg("Error deleting cached images.")
			
		cache_img_dlg.destroy()
		
		return result

	def GetCacheImages(self):
		try:
			for image in os.listdir('/home/user/.maemowordpy/images/'):
				cached_images.append((False, image))
		except: 
			self.show_error_dlg("Error getting cached images.")

	def cache_images_model(self):
		lstore = gtk.ListStore(gobject.TYPE_BOOLEAN, gobject.TYPE_STRING)
		for item in cached_images:
			iter = lstore.append()
			lstore.set(iter, DEL_CACHE_IMAGE, item[DEL_CACHE_IMAGE], CACHE_IMAGE, item[CACHE_IMAGE])
		return lstore

	def cached_img_toggled(self, cell, path, model):
		iter = model.get_iter((int(path),))
		fixed = model.get_value(iter, DEL_CACHE_IMAGE)
		fixed = not fixed
		model.set(iter, DEL_CACHE_IMAGE, fixed)

		if fixed == True:
			a = model.get_value(iter, CACHE_IMAGE)
			cached_images_to_delete.append(a)
		elif fixed == False:
			b = model.get_value(iter, CACHE_IMAGE)
			numero = cached_images_to_delete.index(b)
			print 'cat index: ', numero

	def __add_columns_cache_images(self, treeview):
		model = treeview.get_model()

		renderer = gtk.CellRendererToggle()
		renderer.connect('toggled', self.cached_img_toggled, model)

		column = gtk.TreeViewColumn('Fixed', renderer, active=DEL_CACHE_IMAGE)
		column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
		column.set_fixed_width(50)
		treeview.append_column(column)

		column = gtk.TreeViewColumn('Description', gtk.CellRendererText(), text=CACHE_IMAGE)
		treeview.append_column(column)

	###### More htmltags options ######
	def on_btnparag_clicked(self, widget):
		self.wrap_selection("<p>", "</p>")

	def on_optwrite_clicked(self, widget):
		"""Called when the MoreTags button is clicked"""	
		self.wTree=gtk.glade.XML(glade_file)
		self.optwrite_dlg = self.wTree.get_widget("tagsdialog")
		self.optwrite_dlg.set_transient_for(self.wndMain)
		self.optwrite_dlg.set_default_response(gtk.RESPONSE_CANCEL)

		html_tags_btn = self.wTree.get_widget("html_tags_btn")
		html_tags_btn.connect("clicked", self.on_help, 'html_tags')

		btnleft = self.wTree.get_widget("left")
		left_img = gtk.Image()
		left_img.set_from_file(imgdir + "left.png")
		btnleft.add(left_img)

		btnright = self.wTree.get_widget("right")
		right_img = gtk.Image()
		right_img.set_from_file(imgdir + "right.png")
		btnright.add(right_img)

		btncenter = self.wTree.get_widget("center")
		center_img = gtk.Image()
		center_img.set_from_file(imgdir + "center.png")					
		btncenter.add(center_img)

		btnjustify = self.wTree.get_widget("justify")
		fill_img = gtk.Image()	
		fill_img.set_from_file(imgdir + "fill.png")	
		btnjustify.add(fill_img)
		
		btnMore = self.wTree.get_widget("more")
		more_img = gtk.Image()
		more_img.set_from_file(imgdir + "more.png")
		btnMore.add(more_img)

		btncode = self.wTree.get_widget("code")
		code_img = gtk.Image()
		code_img.set_from_file(imgdir + "code.png")
		btncode.add(code_img)
		
		btnListItem = self.wTree.get_widget("li")
		li_img = gtk.Image() 
		li_img.set_from_file(imgdir + "li.png")
		btnListItem.add(li_img)
		
		btnUnorderedList  = self.wTree.get_widget("ul")
		ul_img = gtk.Image()
		ul_img.set_from_file(imgdir + "ul.png")
		btnUnorderedList.add(ul_img)
		
		btnOrderedList = self.wTree.get_widget("ol")
		ol_img = gtk.Image()
		ol_img.set_from_file(imgdir + "ol.png")
		btnOrderedList.add(ol_img)
		
		btncolor_text = self.wTree.get_widget("color")
		color_img = gtk.Image()
		color_img.set_from_file(imgdir + "font_color.png")
		btncolor_text.add(color_img)
		
		btnbg_color = self.wTree.get_widget("backg")
		bg_img = gtk.Image()
		bg_img.set_from_file(imgdir + "bg_color.png")
		btnbg_color.add(bg_img)

		btnfont_size = self.wTree.get_widget("fontsize")
		fontsize_img = gtk.Image()
		fontsize_img.set_from_file(imgdir + "font_size.png")
		btnfont_size.add(fontsize_img)
		
		btn_super = self.wTree.get_widget("superscript")
		super_img = gtk.Image()
		super_img.set_from_file(imgdir + "superscript.png")
		btn_super.add(super_img)
		
		btn_sub = self.wTree.get_widget("subscript")
		sub_img = gtk.Image()
		sub_img.set_from_file(imgdir + "subscript.png")
		btn_sub.add(sub_img)
		
		btn_tt = self.wTree.get_widget("tt")
		tt_img = gtk.Image()
		tt_img.set_from_file(imgdir + "tt.png")
		btn_tt.add(tt_img)
		
		btn_cite = self.wTree.get_widget("cite")
		cite_img = gtk.Image()
		cite_img.set_from_file(imgdir + "cite.png")
		btn_cite.add(cite_img)
		
		btn_abbr = self.wTree.get_widget("abbr")
		abbr_img = gtk.Image()
		abbr_img.set_from_file(imgdir + "abbr.png")
		btn_abbr.add(abbr_img)
		
		btn_acron = self.wTree.get_widget("acron")	
		acron_img = gtk.Image()
		acron_img.set_from_file(imgdir + "acronym.png")
		btn_acron.add(acron_img)
	
		btnleft.connect("clicked", self.on_more_format_options, 'left')
		btncenter.connect("clicked", self.on_more_format_options, 'center')
		btnright.connect("clicked", self.on_more_format_options, 'right')
		btnjustify.connect("clicked", self.on_more_format_options, 'justify')
		btnMore.connect("clicked", self.on_btnMore_clicked)
		btncode.connect("clicked", self.on_more_format_options, 'code')
		btnListItem.connect("clicked", self.on_more_format_options, 'li')
		btnUnorderedList.connect("clicked", self.on_more_format_options, 'ul')
		btnOrderedList.connect("clicked", self.on_more_format_options, 'ol')
		btncolor_text.connect("clicked", self.on_text_or_bg_color, 'text')
		btnbg_color.connect("clicked", self.on_text_or_bg_color, 'background')
		btnfont_size.connect("clicked", self.on_size_font_clicked)
		btn_super.connect("clicked", self.on_more_format_options, 'sup')
		btn_sub.connect("clicked", self.on_more_format_options, 'sub')
		btn_tt.connect("clicked", self.on_more_format_options, 'tt')
		btn_cite.connect("clicked", 	self.on_more_format_options, 'cite')	
		btn_abbr.connect("clicked", self.on_abbr_or_acron, 'abbr')
		btn_acron.connect("clicked", self.on_abbr_or_acron, 'acronym')
	
		self.optwrite_dlg.show_all()
		self.optwrite_dlg.run()
		self.optwrite_dlg.destroy()

	def on_btnMore_clicked(self, widget):
		self.insert_text("<!--more-->")
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_more_format_options(self, widget, option):
		if option == 'left':
			self.wrap_selection('<div style="text-align: left">', '</div>')
		elif option == 'center':
			self.wrap_selection('<div style="text-align: center">', '</div>')
		elif option == 'right':
			self.wrap_selection('<div style="text-align: right">', '</div>')
		elif option == 'justify':
			self.wrap_selection('<div style="text-align: justify">', '</div>')
		elif option == 'code':
			self.wrap_selection("<code>","</code>")
		elif option == 'ul':
			self.wrap_selection("<ul>","</ul>")
		elif option == 'ol':
			self.wrap_selection("<ol>","</ol>")
		elif option == 'li':
			self.wrap_selection("<li>","</li>")
		elif option == 'sup':
			self.wrap_selection("<sup>","</sup>")
		elif option == 'sub':
			self.wrap_selection("<sub>","</sub>")
		elif option == 'tt':
			self.wrap_selection("<tt>","</tt>")
		elif option == 'cite':
			self.wrap_selection("<cite>","</cite>")
		try:
			self.optwrite_dlg.destroy()
		except: pass
		
	def on_text_or_bg_color(self, widget, option):
		try:
			self.optwrite_dlg.destroy()
		except: pass
		
		#run color selector dialog
		if distro == "chinook":
			color_selector = hildon.ColorChooserDialog()
		else:
			color_selector = hildon.ColorSelector(self.wndMain)

		result = color_selector.run() 
		if (result==gtk.RESPONSE_OK):
			#get color selected
			a=gtk.gdk.Color()
			if distro == "chinook":
				text_color = color_selector.get_color(a)
				colorstring = gtk.color_selection_palette_to_string([a])
			else:
				text_color = color_selector.get_color()
				colorstring = gtk.color_selection_palette_to_string([text_color])
			
			if option == 'text':
				self.wrap_selection('<span style="color:' + colorstring + '">', '</span>')
			elif option == 'background':
				self.wrap_selection('<span style="background-color:' + colorstring + '">', '</span>')
		color_selector.destroy() 

	def on_size_font_clicked(self, widget):
		try:
			self.optwrite_dlg.destroy()
		except: pass
		size_font_dlg = gtk.Dialog(title='Set Font Size', parent=None, flags=gtk.DIALOG_MODAL | gtk.WIN_POS_CENTER, buttons=("Set", gtk.RESPONSE_OK, "Cancel", gtk.RESPONSE_CANCEL))

		font_size_list = gtk.ListStore(gobject.TYPE_STRING)
		font_size = gtk.ComboBoxEntry(font_size_list, 0)	
		size_entry = font_size.child
		size_entry.set_property("editable", False)	
		list_font_size = ["xx-small", "x-small", "small", "medium", "large", "x-large", "xx-large"]
		for item in list_font_size:
			font_size_list.append((item,))

		size_font_dlg.vbox.pack_start(font_size, False, False, 0)
		size_font_dlg.show_all()

		result = size_font_dlg.run() 
		if (result==gtk.RESPONSE_OK):
			fontsize = font_size.get_active_text()
			self.wrap_selection('<span style="font-size:' + fontsize + '">', '</span>')

		size_font_dlg.destroy() 
		
	
	def on_abbr_or_acron(self, widget, option):
		try:
			self.optwrite_dlg.destroy()
		except: pass

		self.wTree=gtk.glade.XML(glade_file)
		dialog = self.wTree.get_widget("main_dialog")
		dialog.set_size_request(300, -1)
		dialog.add_buttons('Cancel', gtk.RESPONSE_CANCEL, 'Insert', gtk.RESPONSE_OK)
		if option == 'abbr':
			title = "Insert Abbreviation"
			textlabel = "Enter abbreviation:"
		elif option == 'acronym':
			title = "Insert Acronym"
			textlabel = "Enter the acronym name:"
		
		dialog.set_title(title)
		dialog.set_default_response(gtk.RESPONSE_CANCEL)
	
		entry = self.wTree.get_widget("main_entry")
		label = self.wTree.get_widget("main_label")
		label.set_text(textlabel)	
			
		result = dialog.run()
		if (result == gtk.RESPONSE_OK):
			if option == 'abbr':
				self.wrap_selection('<abbr title="%s">' % entry.get_text(),"</abbr>")
			elif option == 'acronym':
				self.wrap_selection('<acronym title="%s">' % entry.get_text(),"</acronym>")

		dialog.destroy()

	def on_previewmenu_clicked(self, widget):
		import webbrowser

		##Create html page with text article
		start, end = self.txtBuffer.get_bounds()
		texto_buff = self.txtBuffer.get_text(start, end)
		ext_start, ext_end = self.txtBufferExt.get_bounds()
		ext_texto_buff = self.txtBufferExt.get_text(ext_start, ext_end)
		if ext_texto_buff == "":
			pass
		else:
			texto_buff = texto_buff + '\n\n<a href="">[READ MORE]</a>\n\n' + ext_texto_buff
			
		html_final = texto_buff.replace("\n", "<br />")
		header = "<html><head></head>"
		title = "<h1>"+self.enTitle.get_text()+"</h1><br /><br />"
		body = "<body>"+title+html_final+"</body></html>"
		htmlpage = header+body

		##Create preview file in maemowordpy config dir
		preview_file = open(configdir + "preview", "w")
		preview_file.write(htmlpage)
		preview_file.close()
		##Open the browser with preview file
		webbrowser.open(configdir + "preview", context=osso_c)

	def on_btnSettings_clicked(self, widget):
		"""Called when the settings button is clicked.  It will
		show the dlgSettings dialog and let the user set the WordPress
		blog settings."""
		Preferences()
		
	def on_btncategories_clicked(self, widget):
		if BlogSettings.System == "Wordpress":
			banner = hildon.hildon_banner_show_animation(widget, 'qgn_indi_pball_a', 'Getting categories')
			thread.start_new_thread(self.trat_categories, (widget, banner))
		elif BlogSettings.System == "Blogger":
			self.trat_categories(None, None)
		
	def trat_categories(self, widget, banner):
		if BlogSettings.System == "Blogger":
			self.wTree=gtk.glade.XML(glade_file)
			labels_dialog = self.wTree.get_widget("main_dialog")
			labels_dialog.set_transient_for(self.wndMain)
			labels_dialog.set_size_request(500, -1)
			labels_dialog.add_buttons('Cancel', gtk.RESPONSE_CANCEL, 'Set', gtk.RESPONSE_OK)	
			labels_dialog.set_title("Set Labels")
			labels_dialog.set_default_response(gtk.RESPONSE_CANCEL)
			
			hbox = gtk.HBox()
			help_btn = gtk.Button('Help')
			help_btn.set_size_request(65, 65)
			help_btn.connect('clicked', self.on_help, 'blogger_labels')
			lab1 = gtk.Label()
			hbox.pack_start(help_btn, False, False, 0)
			hbox.pack_start(lab1, True, True, 0)
			labels_dialog.vbox.pack_start(hbox, False, False, 0)
			entry = self.wTree.get_widget("main_entry")
			label = self.wTree.get_widget("main_label")
			label.set_text("Enter labels:")	
			
			labels_dialog.show_all()
			result = labels_dialog.run()
			if (result == gtk.RESPONSE_OK):
				self.labels = entry.get_text()

			labels_dialog.destroy()

		elif BlogSettings.System == "Wordpress":
			result = gtk.RESPONSE_CANCEL
	
			categories_dlg = gtk.Dialog(title='Set Categories', parent=None, flags=gtk.DIALOG_MODAL | gtk.WIN_POS_CENTER, buttons=("Set", gtk.RESPONSE_OK, "Cancel", gtk.RESPONSE_CANCEL))
			categories_dlg.set_transient_for(self.wndMain)
			categories_dlg.set_default_size(300, 250)

			vbox1 = gtk.VBox(False, 8)

			sw = gtk.ScrolledWindow()
			if distro == 'chinook':
				if BlogSettings.Fingermenu == 'True':
					hildon.hildon_helper_set_thumb_scrollbar(sw, True)
			sw.set_shadow_type(gtk.SHADOW_ETCHED_IN)
			sw.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
			vbox1.pack_start(sw)

			# clear categories chosen before
			del cats[:]
			del data[:]

			## Get category list from Wordpress blog
			self.GetCategoryList(banner)	

			if data == []:
				return
			model = self.__create_model()

			treeview = gtk.TreeView(model)
			treeview.set_rules_hint(True)
			if distro == 'chinook':
				pass
			else:
				treeview.set_property("allow-checkbox-mode", False)
			treeview.set_search_column(COLUMN_DESCRIPTION)

			sw.add(treeview)

			self.__add_columns(treeview)
			categories_dlg.vbox.pack_start(vbox1, True, True, 0)
			categories_dlg.show_all()
		
			banner.destroy()
		
			gtk.gdk.threads_enter()
			result = categories_dlg.run()
			gtk.gdk.threads_leave()
		
			if (result==gtk.RESPONSE_OK):
				cats2 = cats
				print 'categories added: ', cats2
				gtk.gdk.threads_enter()
				categories_dlg.destroy()
				gtk.gdk.threads_leave()
			
			gtk.gdk.threads_enter()
			categories_dlg.destroy()
			gtk.gdk.threads_leave()
		
			return result

	def GetCategoryList(self, banner):
		#Try to get the wordpress client
		try:
			wp = BlogSettings.create_wordpress_client()
			#Select blog. TODO: choose if there is more than one blog
			wp.selectBlog(0)
			categories = tuple(wp.getCategoryList())
			#Save category list in [data]
			for i in categories:
				a = False
				b = i.name
				c = (a, b)
				data.append(c)
			##Sort categories alphabetically
			data.sort()
		except: 
			banner.destroy()
			gtk.gdk.threads_enter()
			self.show_error_dlg("Error creating Wordpress client.\nPlease check settings or connection.")
			gtk.gdk.threads_leave()

	def __create_model(self):
		lstore = gtk.ListStore(gobject.TYPE_BOOLEAN, gobject.TYPE_STRING)
		#Added the category list to lstore
		for item in data:
			iter = lstore.append()
			lstore.set(iter, COLUMN_FIXED, item[COLUMN_FIXED], COLUMN_DESCRIPTION, item[COLUMN_DESCRIPTION])
		return lstore

	def fixed_toggled(self, cell, path, model):
        # get toggled iter
		iter = model.get_iter((int(path),))
		fixed = model.get_value(iter, COLUMN_FIXED)
        # do something with the value
		fixed = not fixed
        # set new value
		model.set(iter, COLUMN_FIXED, fixed)

		#If togglebutton is choose, add category name
		#to [cats]
		if fixed == True:
			a = model.get_value(iter, COLUMN_DESCRIPTION)
			cats.append(a)
		#If togglebutton is choose and delete,
		#delete category name from [cats]
		elif fixed == False:
			b = model.get_value(iter, COLUMN_DESCRIPTION)
#			print 'delete cat: ', b
			numero = cats.index(b)
#			print 'cat index: ', numero
			del cats[numero]

	def __add_columns(self, treeview):
		model = treeview.get_model()

        # column for fixed toggles
		renderer = gtk.CellRendererToggle()
		renderer.connect('toggled', self.fixed_toggled, model)

		column = gtk.TreeViewColumn('Fixed', renderer, active=COLUMN_FIXED)
        # set this column to a fixed sizing(of 50 pixels)
		column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
		column.set_fixed_width(50)
		treeview.append_column(column)

        # column for description
		column = gtk.TreeViewColumn('Description', gtk.CellRendererText(), text=COLUMN_DESCRIPTION)
		treeview.append_column(column)


	def on_btngetarticles_clicked(self, widget):	
		banner = hildon.hildon_banner_show_animation(widget, 'qgn_indi_pball_a', 'Getting articles')
		thread.start_new_thread(self.trat_articles, (widget, banner))
		
	def trat_articles(self, widget, banner):
		result = gtk.RESPONSE_CANCEL
		
		articles_dlg = gtk.Dialog(title='Delete Articles', parent=None, flags=gtk.DIALOG_MODAL | gtk.WIN_POS_CENTER, buttons=("Delete", gtk.RESPONSE_OK, "Cancel", gtk.RESPONSE_CANCEL))
		articles_dlg.set_transient_for(self.wndMain)
		articles_dlg.set_default_size(-1, 250)

		vbox1 = gtk.VBox(False, 8)

		sw = gtk.ScrolledWindow()
		if distro == 'chinook':
			if BlogSettings.Fingermenu == 'True':
				hildon.hildon_helper_set_thumb_scrollbar(sw, True)
		sw.set_shadow_type(gtk.SHADOW_ETCHED_IN)
		sw.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
		vbox1.pack_start(sw)

		# clear articles chosen before
		del del_articles[:]
		del data_articles[:]
		
		self.GetArticlesList(banner)	

		if data_articles == []:
			return
		
		model = self.__articles_model()

		treeview = gtk.TreeView(model)
		treeview.set_rules_hint(True)
		if distro == 'chinook':
			pass
		else:
			treeview.set_property("allow-checkbox-mode", False)
		treeview.set_search_column(COLUMN_DESCRIPTION)

		sw.add(treeview)

		self.__add_articles_columns(treeview)

		articles_dlg.vbox.pack_start(vbox1, True, True, 0)
		articles_dlg.show_all()
		banner.destroy()
			
		gtk.gdk.threads_enter()
		result = articles_dlg.run()
		gtk.gdk.threads_leave()
		
		if (result==gtk.RESPONSE_OK):
		
			try:
				if BlogSettings.System == "Wordpress":
					wp = BlogSettings.create_wordpress_client()
				elif BlogSettings.System == "Blogger":
					wp = BlogSettings.create_blogger_client()
				thread.start_new_thread(self.delete_posts, (wp,))					
				gtk.gdk.threads_enter()
				self.pgbar = ProgressBar("Deleting", self.wndMain)
				gtk.gdk.threads_leave()
			except:
				thread.start_new_thread(self.error_post, ("Error deleting article(s).",))
				
		gtk.gdk.threads_enter()
		articles_dlg.destroy()
		gtk.gdk.threads_leave()
		return result
	
	def delete_posts(self, wp):
		try:
			if BlogSettings.System == "Wordpress":
				for i in del_articles:
					wp.deletePost(i)
			elif BlogSettings.System == "Blogger":
				for i in del_articles:
					wp.Delete(i)

			self.pgbar.stop_pg()
			thread.start_new_thread(self.success_dlg, ("Success! Article(s) deleted.",))
		except:
			thread.start_new_thread(self.error_post, ("Error deleting article(s).",))

				
	def GetArticlesList(self, banner):
		try:
			if BlogSettings.System == "Wordpress":
				wp = BlogSettings.create_wordpress_client()
				wp.selectBlog(0)
				articles = wp.getRecentPosts(int(BlogSettings.Articles_num))
				for i in articles:
					a = False
					b = i.title
					c = i.id
					d = (a, b, c)
					data_articles.append(d)
				return
			elif BlogSettings.System == "Blogger":
				wp = BlogSettings.create_blogger_client()
    			# Request the feed.
				feed = wp.GetFeed('/feeds/' + BlogSettings.Blogid + '/posts/default')
    			for entry in feed.entry:
					a = False
					b = entry.title.text
					c = entry.GetEditLink().href
					d = (a, b, c)
					data_articles.append(d)
		except: 
			banner.destroy()
			gtk.gdk.threads_enter()
			self.show_error_dlg("Error creating Wordpress client.\nPlease check settings or connection.")
			gtk.gdk.threads_leave()

	def __articles_model(self):
		lstore = gtk.ListStore(gobject.TYPE_BOOLEAN, gobject.TYPE_STRING, gobject.TYPE_STRING)

		for item in data_articles:
			iter = lstore.append()
			lstore.set(iter, COLUMN_ARTICLE_FIXED, item[COLUMN_ARTICLE_FIXED], COLUMN_ARTICLE, item[COLUMN_ARTICLE], COLUMN_ID, item[COLUMN_ID])
		return lstore

	def articles_toggled(self, cell, path, model):
		iter = model.get_iter((int(path),))
		fixed = model.get_value(iter, COLUMN_ARTICLE_FIXED)
		fixed = not fixed

		model.set(iter, COLUMN_ARTICLE_FIXED, fixed)

		if fixed == True:
			a = model.get_value(iter, COLUMN_ID)
			del_articles.append(a)

		elif fixed == False:
			b = model.get_value(iter, COLUMN_ID)
			numero = del_articles.index(b)
			del del_articles[numero]


	def __add_articles_columns(self, treeview):
		model = treeview.get_model()

		renderer = gtk.CellRendererToggle()
		renderer.connect('toggled', self.articles_toggled, model)

		column = gtk.TreeViewColumn('Fixed', renderer, active=COLUMN_ARTICLE_FIXED)
		column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
		column.set_fixed_width(50)
		treeview.append_column(column)

		column = gtk.TreeViewColumn('Description', gtk.CellRendererText(), text=COLUMN_ARTICLE)
		treeview.append_column(column)
		
		column = gtk.TreeViewColumn('Id', gtk.CellRendererText(), text=COLUMN_ID)
		column.set_visible(False)
		treeview.append_column(column)
		

	def technorati_tags(self):
		"""Get the technorati tags."""
		#Get tags from text entry
		tags = self.en_tags.get_text()
		#Separate the tags in a list
		tagsArray = []
		for item in tags.split(";"):
			tagsArray.append(item)
		#Create the technorati tag model
		lista = []
		for tag in tagsArray:
			llave = '<a href="http://technorati.com/tag/' + tag + '" rel="tag">' + tag + '</a>'
			lista.append(llave)
		#Separate each link
		self.texto_technorati = (', ').join(lista)


	def on_btnpost_clicked(self, widget):
		#Try to get the wordpress client
		if BlogSettings.System == "Wordpress":
			wp = BlogSettings.create_wordpress_client()
			if (wp == None):
				#Error creating Client, setting maybe wrong
				self.show_error_dlg("Error creating Wordpress client.\nPlease check settings or connection.")
				#Now get out of here
				return
		elif BlogSettings.System == "Blogger":
			wp = BlogSettings.create_blogger_client()
		if self.enTitle.get_text() == '':
			self.show_error_dlg("You must write a title. See in Advanced Edit tab.")
			return			

		try:
			self.posting = True
			thread.start_new_thread(self.trat_post, (wp,))				
			self.pgbar = ProgressBar("Publishing", self.wndMain)
		except:
			self.pgbar.stop_pg()
			thread.start_new_thread(self.error_post, ("Error publishing article.",))
	
		thread.start_new_thread(self.upload_post, (wp,))

	def trat_post(self, wp):
		if BlogSettings.System == "Blogger":
			self.post = gdata.GDataEntry()
			title = self.enTitle.get_text()
			self.post.title = atom.Title(title_type='xhtml', text=title)
			#Text
			start, end = self.txtBuffer.get_bounds()
			texto_post = self.txtBuffer.get_text(start, end)
			###upload local images, and replace its filename for its url###
			#TODO: comment this
			if texto_post.find("file://") >= 0:
				import re
				for i in range(texto_post.count('file://')):
					hele = re.compile(r'"file://[^$%]+"')
					a = hele.findall(texto_post)
					if a[0].count('"') == 2:
						b = a[0]
						c = b.replace('"', '')
					else:
						b = a[0].split('"')
						for j in range(len(b)):
							if b[j].find("file://") >= 0:					
								c = b[j].replace('"', '')

					d = c.replace('file://', '')

					if os.path.exists(d):
						pass
					else:
						self.pgbar.stop_pg()
						gtk.gdk.threads_enter()
						self.show_error_dlg("Error uploading image:\nFile doesn't exist.")
						gtk.gdk.threads_leave()
						return
					try:
						##For Blogger upload to Picasa
						self.pgbar.progress.set_text('Uploading images')
						service = gdata.photos.service.PhotosService()
						service.ClientLogin(BlogSettings.Username, BlogSettings.Password)
						
						## Some code for MaemoPublishr :) ##
						img = None
						# Get album feed
						albums = service.GetUserFeed().entry        
						# See if the album exists
						for a in albums:
							if a.title.text == 'Maemo WordPy':
								img = service.InsertPhotoSimple(a, 'wordpy-image', '', d)
						# The selected album was not found, create new one
						if not img:
							new_album = service.InsertAlbum(title='Maemo WordPy', summary='Images inserted with Maemo WordPy blogging client.')
							img = service.InsertPhotoSimple(new_album, 'wordpy-image', '', d)

						photo_urls = []
						for i in img.link:
							photo_urls.append(i.href)
						imageSrc = photo_urls[4]
						#print 'source:', imageSrc
						del photo_urls
					except gdata.photos.service.GooglePhotosException, e: 
						self.pgbar.stop_pg()
						gtk.gdk.threads_enter()
						self.show_error_dlg("Error uploading image to Picasa Web Albums.\nError: %s\nPerhaps you need to activate Picasa Web Albums." % e[2])
						gtk.gdk.threads_leave()
						return
					except:
						self.pgbar.stop_pg()
						gtk.gdk.threads_enter()
						self.show_error_dlg("Error uploading image to Picasa Web Albums.")
						gtk.gdk.threads_leave()
						return
					####if d is a edited temp image, delete it###
					if d.find('maemowordpy') >= 0:
						os.remove(d)
					texto_post = texto_post.replace(c, imageSrc)
					#print 'post:', texto_post				

			self.pgbar.progress.set_text('Publishing')
			#Execute technorati tags
			self.technorati_tags()
			#If there aren't tags 
			if self.texto_technorati == '<a href="http://technorati.com/tag/" rel="tag"></a>':
				nuevo_texto = texto_post
			#If there are tags add the links to main post
			else: 
				nuevo_texto = texto_post + '<br /><br />' + '<p style="text-align: right"><small>Technorati Tags: ' + self.texto_technorati + '</small><br /></p>'

			content = nuevo_texto
			self.post.content = atom.Content(content_type='html', text=content)

			## Set labels to blogger post
			if self.labels:
				self.post.category = atom.Category()
				self.post.category.term = self.labels
				self.post.category.scheme = "http://www.blogger.com/atom/ns#"
			else:
				print 'no labels.'
			# Get publish/draft post
			if not self.pub_button.get_active() == True:
				control = atom.Control()
				control.draft = atom.Draft(text='yes')
				self.post.control = control
			self.posting = False

		elif BlogSettings.System == "Wordpress":
			self.post = wordpresslib.WordPressPost()

		# Allow Pings
			if self.ping_button.get_active() == True:
				self.post.allowPings = True
			else:
				self.post.allowPings = '0'

			# Allow Comments
			if self.comm_button.get_active() == True:
				self.post.allowComments = True
			else:
				self.post.allowComments = 'False'

			#Title
			self.post.title = self.enTitle.get_text()
			#Text
			start, end = self.txtBuffer.get_bounds()
			texto_post = self.txtBuffer.get_text(start, end)

			###upload local images, and change its filename for its url###
			if texto_post.find("file://") >= 0:
				import re, xmlrpclib
				for i in range(texto_post.count('file://')):
					hele = re.compile(r'"file://[^$%]+"')
					a = hele.findall(texto_post)
					if a[0].count('"') == 2:
						b = a[0]
						c = b.replace('"', '')
					else:
						b = a[0].split('"')
						for j in range(len(b)):
							if b[j].find("file://") >= 0:					
								c = b[j].replace('"', '')

					d = c.replace('file://', '')

					if os.path.exists(d):
						pass
					else:
						self.pgbar.stop_pg()
						gtk.gdk.threads_enter()
						self.show_error_dlg("Error uploading image:\nFile doesn't exist.")
						gtk.gdk.threads_leave()
						return

					try:
						self.pgbar.progress.set_text('Uploading images')				
						imageSrc = wp.newMediaObject(d)
					except wordpresslib.WordPressException, e:
						self.pgbar.stop_pg()
						gtk.gdk.threads_enter()
						self.show_error_dlg(
						"Error uploading image:\nError code: %s\nError Message: %s"
						% (e.id, e.message))
						gtk.gdk.threads_leave()
						return
					except xmlrpclib.Fault, e:
						self.pgbar.stop_pg()
						gtk.gdk.threads_enter()
						self.show_error_dlg(
						"Error uploading image:\nError code: %s\nError Message: %s"
						% (e.faultCode, e.faultString))
						gtk.gdk.threads_leave()
						return
					except xmlrpclib.ProtocolError, e:
						self.pgbar.stop_pg()
						gtk.gdk.threads_enter()
						self.show_error_dlg(
						"Error uploading image:\nURL: %s\nError code: %s\nError Message: %s"
						% (e.url, e.errcode, e.errmsg))
						gtk.gdk.threads_leave()
						return
					except:
						self.pgbar.stop_pg()
						gtk.gdk.threads_enter()
						self.show_error_dlg("Error uploading image.")
						gtk.gdk.threads_leave()
						return
					####if d is a edited temp image, delete it###
					if d.find('maemowordpy') >= 0:
						os.remove(d)
					texto_post = texto_post.replace(c, imageSrc)				

			self.pgbar.progress.set_text('Publishing')
			#Execute technorati tags
			self.technorati_tags()
			#If there aren't tags 
			if self.texto_technorati == '<a href="http://technorati.com/tag/" rel="tag"></a>':
				nuevo_texto = texto_post
			#If there are tags add the links to main post
			else: 
				nuevo_texto = texto_post + '<br /><br />' + '<p style="text-align: right"><small>Technorati Tags: ' + self.texto_technorati + '</small><br /></p>'

			self.post.description = nuevo_texto
			#TextMore
			start, end = self.txtBufferExt.get_bounds()
			self.post.textMore = self.txtBufferExt.get_text(start, end)
			#Excerpt
			start, end = self.txtBufferExc.get_bounds()
			self.post.excerpt = self.txtBufferExc.get_text(start, end)
			#Trackbacks 
			trackbackArray = []
			trackbackURLS = self.en_track.get_text()
			for item in trackbackURLS.split(";"):
				trackbackArray.append(item)

			self.post.trackbacks=trackbackArray
			#Categories
			del idfromcat[:]
			for i in range(len(cats)):
				mj = wp.getCategoryIdFromName(cats[i])
				idfromcat.append(mj) 

			self.post.categories = idfromcat

			# Get publish/draft post
			if self.pub_button.get_active() == True:
				self.publish = True
			elif self.pub_button.get_active() == False:
				self.publish = False

			self.posting = False

	def upload_post(self, wp):
		"""Called when the post button is clicked, this will
		post the post to the blog."""
		import time
		##while it's treated all posting text, wait
		while self.posting:
			time.sleep(0.5)

		#Now post the post!
		import xmlrpclib
		try:
			if BlogSettings.System == "Blogger":
				## Cambiar por blog_settings.blog_id
				wp.Post(self.post, '/feeds/' + BlogSettings.Blogid + '/posts/default')
			elif BlogSettings.System == "Wordpress":
				new_post_id = wp.newPost(self.post, self.publish)
				#last_post = wp.getLastPost()
				#print last_post
				#link = last_post.link
				#print link
				#title = last_post.title
				#print title
				#jaiku_api.PostPresence(text=str(title) + ": " + str(link), location='Somewhere with Maemo WordPy')
			self.pgbar.stop_pg()
			thread.start_new_thread(self.success_dlg, ("Success! Article has been published!", ))
		except xmlrpclib.Fault, e:
			self.pgbar.stop_pg()
			thread.start_new_thread(self.error_post, ("Error publishing article:\nError code: %s\nError Message: %s" % (e.faultCode, e.faultString),))
		except xmlrpclib.ProtocolError, e:
			self.pgbar.stop_pg()
			thread.start_new_thread(self.error_post, ("Error publishing article:\nURL: %s\nError code: %s\nError Message: %s" % (e.url, e.errcode, e.errmsg),))
		except:
			self.pgbar.stop_pg()
			thread.start_new_thread(self.error_post, ("Error publishing article.",))

	def success_dlg(self, msg):
		success_dlg = gtk.MessageDialog(type=gtk.MESSAGE_INFO, message_format=msg, buttons=gtk.BUTTONS_CLOSE)
		success_dlg.set_modal(True)
		gtk.gdk.threads_enter()
		success_dlg.run()
		gtk.gdk.threads_leave()
		success_dlg.destroy()
		return True

	def error_post(self, msg):
		error_post_dlg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR, message_format=msg, buttons=gtk.BUTTONS_CLOSE)
		error_post_dlg.set_modal(True)
		gtk.gdk.threads_enter()
		error_post_dlg.run()
		gtk.gdk.threads_leave()
		error_post_dlg.destroy()
		return True

	def help_dialog(self, title, transient, wsize, hsize, text):
		## This is the generic help dialog
		dialog = gtk.Dialog(title=title, parent=None, flags=gtk.WIN_POS_CENTER, buttons=('Close', gtk.RESPONSE_CLOSE))
		dialog.set_size_request(wsize, hsize)
		dialog.set_transient_for(transient)

		swin = gtk.ScrolledWindow()
		swin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
		if distro == 'chinook':
			if BlogSettings.Fingermenu == 'True':
				hildon.hildon_helper_set_thumb_scrollbar(swin, True)
		txtview = gtk.TextView()
		buffer1 = txtview.get_buffer()
		txtview.set_wrap_mode(gtk.WRAP_WORD)		
		txtview.set_editable(False)
		txtview.set_cursor_visible(False)
		
		buffer1.set_text(text)

		swin.add(txtview)
		dialog.vbox.pack_start(swin, True, True, 0)	
		
		dialog.show_all()
		dialog.run()
		dialog.destroy()

	def browse_for_image(self, widget, image):
		"""This function is used to browse for an image.
		The path to the image will be returned if the user
		selects one, however a blank string will be returned
		if they cancel or do not select one."""
		fileopen_dlg = hildon.FileChooserDialog(self.wndMain, gtk.FILE_CHOOSER_ACTION_OPEN)
		fileopen_dlg.set_title("Browse Image")
		fileopen_dlg.set_transient_for(self.image_dlg)
		fileopen_dlg.set_current_folder('/home/user/MyDocs/.images')

		fileopen_dlg.set_default_response(gtk.RESPONSE_OK)
		"""Init the return value"""
		result = ""
		if fileopen_dlg.run() == gtk.RESPONSE_OK:
			try:
				result = fileopen_dlg.get_filename()
				self.new_pixbuf = gtk.gdk.pixbuf_new_from_file(result)
				self.img_width.set_value(self.new_pixbuf.get_width())
				self.img_height.set_value(self.new_pixbuf.get_height())
			
				self.image_filename = result
				w, h = self.set_thumbnail_size(self.new_pixbuf, False)

				image_pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(result, int(w), int(h))
			
				image.set_from_pixbuf(image_pixbuf)
				image.show()
			except:
				print 'No image file.'
				result = None

		fileopen_dlg.destroy()

		if result != None:
			self.en_imgsrc.set_text("file://" + result)			

		return result

	def get_selection_iters(self):
		"""This function gets the start and end selection
		iters from the text view.  If there is no selection
		the current position of the cursor will be returned.
		Returns - start,end - gtk.TextIter objects"""

		#init
		start = None
		end = None

		if self.txtPost.is_focus() == 1:
			self.txtBuffer = self.txtPost.get_buffer()
		elif self.txtPostExt.is_focus() == 1:
			self.txtBuffer = self.txtPostExt.get_buffer()
		elif self.txtPostExc.is_focus() == 1:
			self.txtBuffer = self.txtPostExc.get_buffer()

		#First check to see that the text buffer is valid
		if (not self.txtBuffer):
			self.show_error_dlg("Text buffer not available")
			return start,end

		#Get the selection bounds
		bounds = self.txtBuffer.get_selection_bounds();
		if (bounds):
			#If there is a selection we are done
			start,end = bounds
		else:
			#There is no selection so just get the cursor mark
			cursor_mark = self.txtBuffer.get_insert()
			"""Set start and end to be gtk.TextIter objercts at the
			position of the cursor mark"""
			start = self.txtBuffer.get_iter_at_mark(cursor_mark)
			end = self.txtBuffer.get_iter_at_mark(cursor_mark)

		return start, end

	def insert_text(self, text):
		"""This function inserts text into the text buffer
		self.txtBuffer at the current selection.  If text is
		selected it will be overwritten, otherwise it will simply be
		inserted at the cursor position
		text - The text to be inserted in the buffer
		"""

		if self.txtPost.is_focus() == 1:
			self.txtBuffer = self.txtPost.get_buffer()
		elif self.txtPostExt.is_focus() == 1:
			self.txtBuffer = self.txtPostExt.get_buffer()
		elif self.txtPostExc.is_focus() == 1:
			self.txtBuffer = self.txtPostExc.get_buffer()

		start, end = self.get_selection_iters();

		if ((not start)or(not end)):
			self.show_error_dlg("Error inserting text")
			return;

		#Delete the selected text (start and end will be equal after)
		self.txtBuffer.delete(start,end)
		#Save a mark at the start position since after we insert
		#the text start will be invalid
		start_mark = self.txtBuffer.create_mark(None, start, True)
		#Insert, end will be set to the end insert position
		self.txtBuffer.insert(end,text)
		start = self.txtBuffer.get_iter_at_mark(start_mark)
		#select the text, use end as the first param so that
		#it will be the cursor position
		self.txtBuffer.select_range(end,start)
		#delete the start mark
		self.txtBuffer.delete_mark(start_mark)

	def wrap_selection(self, start_tag, end_tag):
		"""This fucntion is used to wrap the currently selected
		text in the gtk.TextView with start_tag and end_tag. If
		there is no selection start_tag and end_tag will be
		inserted at the cursor position
		start_tag - The text that will go at the start of the
		selection.
		end_tag - The text that will go at the end of the
		selection."""

		if self.txtPost.is_focus() == 1:
			self.txtBuffer = self.txtPost.get_buffer()
		elif self.txtPostExt.is_focus() == 1:
			self.txtBuffer = self.txtPostExt.get_buffer()
		elif self.txtPostExc.is_focus() == 1:
			self.txtBuffer = self.txtPostExc.get_buffer()

		start, end = self.get_selection_iters();
		if ((not start)or(not end)):
			self.show_error_dlg("Error inserting text")
			return;
		#Create a mark at the start and end
		start_mark = self.txtBuffer.create_mark(None,start, True)
		end_mark = self.txtBuffer.create_mark(None, end, False)
		#Insert the start_tag
		self.txtBuffer.insert(start, start_tag)
		#Get the end iter again
		end = self.txtBuffer.get_iter_at_mark(end_mark)
		#Insert the end tag
		self.txtBuffer.insert(end, end_tag)
		#Get the start and end iters
		start = self.txtBuffer.get_iter_at_mark(start_mark)
		end = self.txtBuffer.get_iter_at_mark(end_mark)
		#Select the text
		self.txtBuffer.select_range(end,start)
		#Delete the gtk.TextMark objects
		self.txtBuffer.delete_mark(start_mark)
		self.txtBuffer.delete_mark(end_mark)


class WordPressBlogSettings:
	"""This class holds the necessary wordpress blog settings
	URL - The URL of the blog
	Username - The username posting
	Password - The password for the username
	"""
	def __init__(self, URL="", Username="", System ="", Password="", Blogid="", Blogtitle="", Articles_num=8, Flickr_num=5, Fingermenu="True", Fontsize="12"):
		self.URL = URL
		self.Username = Username
		self.Username = Username
		self.System = System
		self.Password = Password
		self.Blogid = Blogid
		self.Blogtitle = Blogtitle
		self.Articles_num = Articles_num
		self.Flickr_num = Flickr_num
		self.Fingermenu = Fingermenu
		self.Fontsize = Fontsize
		
	def create_wordpress_client(self):
		"""Quick helper routine used to create the wordpress
		client"""
		# prepare client object
		try:
			wp = wordpresslib.WordPressClient(self.URL, self.Username, self.Password)
		except:
			return None

		# select blog id
		wp.selectBlog(0)

		return wp

	def create_blogger_client(self):
		"""Creates a GDataService and provides ClientLogin auth details to it.
		"""
		# Authenticate using ClientLogin.
		service = gdata.service.GDataService(self.Username, self.Password)
		service.source = 'Maemo WordPy'
		service.service = 'blogger'
		service.server = 'www.blogger.com'
		service.ProgrammaticLogin()

		return service

class ProgressBar:
	def __init__(self, pg_text, window):
		self.w = gtk.Dialog('Maemo WordPy', None)
		self.w.set_transient_for(window)
		vbox = gtk.VBox(False, 5)
		self.progress = gtk.ProgressBar()
		self.progress.set_size_request(250,-1)
		self.progress.set_text(pg_text)
		vbox.add(self.progress)
		self.w.vbox.add(vbox)
		self.w.show_all()

		self.active = True
		self.progress.pulse()
		self.timeout_cb = gobject.timeout_add(200, self.increment)

	def stop_pg(self):
		self.active = False
		self.w.destroy()

	def increment(self):        
		if not self.active:
            # we were disabled, so stop pulsating
			return False
		self.progress.pulse()
		return True

class Preferences:
	def __init__(self):	
		self.acctree=gtk.glade.XML(preferences_glade)
		self.Preferences_win = self.acctree.get_widget("window1")
		self.Preferences_win.set_size_request(600, 400)
		self.Preferences_win.set_transient_for(app.wndMain)
		self.Preferences_win.set_title("Preferences")
			
		del cuentas[:]
		self.GetAccounts()	
			
		self.model = self.__accounts_model()
		
		treeview = self.acctree.get_widget("treeview1")
		treeview.set_headers_visible(True)
		treeview.set_rules_hint(True)
		treeview.set_model(self.model)
		treeview.connect("button-press-event", self.on_button_press, treeview)
		
		self.__accounts_columns(treeview)
		
		button1 = self.acctree.get_widget("button1")
		button1.connect("clicked", self.on_add_clicked, treeview, False)
		
		button5 = self.acctree.get_widget("button5")
		button5.connect("clicked", self.on_modify_clicked, treeview)
		
		button2 = self.acctree.get_widget("button2")
		button2.connect("clicked", self.on_delete_clicked, treeview)		
		
		button3 = self.acctree.get_widget("button3")
		button3.connect("clicked", self.close_preferences)
		
		accounts_help_btn = self.acctree.get_widget("accounts_help_btn")
		accounts_help_btn.connect("clicked", self.on_help_preferences, 'accounts')

		### flickr tab ####				
		button4 = self.acctree.get_widget("button4")
		button4.connect("clicked", self.on_authorize_flickr)
		
		hbox5 = self.acctree.get_widget("hbox5")
		self.photo_num = hildon.NumberEditor(1, 100)
		self.photo_num.set_value(int(BlogSettings.Flickr_num))
		hbox5.pack_start(self.photo_num, False, False, 0)
		hbox5.reorder_child(self.photo_num, 1)	

		flickr_help_btn = self.acctree.get_widget("flickr_help_btn")
		flickr_help_btn.connect("clicked", self.on_help_preferences, 'flickr')
	
		#### Others tab ####
		hbox8 = self.acctree.get_widget("hbox8")
		self.articles_num = hildon.NumberEditor(1, 100)
		self.articles_num.set_value(int(BlogSettings.Articles_num))
		hbox8.pack_start(self.articles_num, False, False, 0)
		hbox8.reorder_child(self.articles_num, 1)

		hbox11 = self.acctree.get_widget("hbox11")
		self.fontsize_num = hildon.NumberEditor(9, 30)
		self.fontsize_num.set_value(int(BlogSettings.Fontsize))
		hbox11.pack_start(self.fontsize_num, False, False, 0)
		hbox11.reorder_child(self.fontsize_num, 2)
	
		others_help_btn = self.acctree.get_widget("others_help_btn")
		others_help_btn.connect("clicked", self.on_help_preferences, 'others')

		self.menufinger = self.acctree.get_widget("checkbutton1")
		
		if distro == 'chinook':
			pass
		else:
			self.menufinger.set_sensitive(False)

		if BlogSettings.Fingermenu == 'True':
			self.menufinger.set_active(True)
		else:
			self.menufinger.set_active(False)
		
		self.Preferences_win.show_all()

	def on_help_preferences(self, widget, help):
		if help == 'flickr':
			from help_file import preferences_flickr_help as help
			title = 'Flickr Preferences'
		elif help == 'accounts':
			from help_file import preferences_accounts_help as help
			title = 'Accounts Preferences'		
		elif help == 'others':
			from help_file import preferences_others_help as help
			title = 'Others Preferences'

		app.help_dialog(title=title, transient=app.wndMain, wsize=620, hsize=340, text=help)

	def on_button_press(self, widget, event, treeview):
		if event.button == 1 and event.type == gtk.gdk._2BUTTON_PRESS:
			self.on_modify_clicked(widget, treeview)
	
	def close_preferences(self, widget):
		BlogSettings.Articles_num = self.articles_num.get_value()
		BlogSettings.Flickr_num = self.photo_num.get_value()
		BlogSettings.Fingermenu = str(self.menufinger.get_active())
		BlogSettings.Fontsize = str(self.fontsize_num.get_value())
		app.set_font_textview()
		
		settings_file=open(configdir + 'settings.conf', 'w')	
		config.set("Settings", "fingerscroll", str(self.menufinger.get_active()))
		config.set("Settings", "flickrphotos", str(self.photo_num.get_value()))
		config.set("Settings", "num_articles", str(self.articles_num.get_value()))
		config.set("Settings", "fontsize", str(self.fontsize_num.get_value()))
	
		config.write(settings_file)
		settings_file.close()
		
		self.Preferences_win.destroy()
		
	def __accounts_model(self):
		lstore = gtk.ListStore(gobject.TYPE_BOOLEAN, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING)
		
		for item in cuentas:
			iter = lstore.append()
			lstore.set(iter, ENABLED, item[ENABLED], ACCOUNTTITLE, item[ACCOUNTTITLE], BLOGURL, item[BLOGURL], BLOGUSER, item[BLOGUSER], BLOGSYSTEM, item[BLOGSYSTEM], BLOGPASS, item[BLOGPASS], BLOGID, item[BLOGID], BLOGTITLE, item[BLOGTITLE])
		return lstore
		
	def __accounts_columns(self, treeview):
		renderer = gtk.CellRendererToggle()
		renderer.connect("toggled", self.on_toggled_fixed)
		#column for enabled
		column = gtk.TreeViewColumn('Enabled', renderer, active=ENABLED)
		column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
		column.set_fixed_width(105)
		treeview.append_column(column)

        # column for blog title
		column = gtk.TreeViewColumn('Account', gtk.CellRendererText(), text=ACCOUNTTITLE)
		column.set_property("expand", True)
		treeview.append_column(column)
		
        # column for url
		column = gtk.TreeViewColumn('URL', gtk.CellRendererText(), text=BLOGURL)
		column.set_property("visible", False)
		column.set_property("expand", True)
		treeview.append_column(column)

        # column for user
		column = gtk.TreeViewColumn('User', gtk.CellRendererText(), text=BLOGUSER)
		column.set_property("expand", True)
		column.set_property("visible", False)
		treeview.append_column(column)

        # column for system
		column = gtk.TreeViewColumn('System', gtk.CellRendererText(), text=BLOGSYSTEM)
		column.set_property("expand", True)
		treeview.append_column(column)
		
        # column for password
		column = gtk.TreeViewColumn('Password', gtk.CellRendererText(), text=BLOGPASS)
		column.set_property("visible", False)
		treeview.append_column(column)

        # column for blogid
		column = gtk.TreeViewColumn('BlogId', gtk.CellRendererText(), text=BLOGID)
		column.set_property("visible", False)
		treeview.append_column(column)

        # column for blogid
		column = gtk.TreeViewColumn('Blog Title', gtk.CellRendererText(), text=BLOGTITLE)
		column.set_property("visible", False)
		treeview.append_column(column)

	def on_toggled_fixed(self, cell, path):
		title, fixed, iter = self.make_default(path)
		
		if fixed == True or not fixed:
			newtitle = self.model.get_value(iter, ACCOUNTTITLE)
			
			for i in cuentas:
				if str(i).find('True') >= 0:
					indice = cuentas.index(i)
				elif str(i).find(newtitle) >= 0:
					true_indice  = cuentas.index(i)
				
			try:
				if str(newtitle) == cuentas[indice][1]:
					#print 'iguales.'
					#print cuentas
					return
			except:
				pass
					
			if cuentas == [] or len(cuentas) == 1:
				pass
				
			else:
				try:
					old_default_acc = cuentas[indice]
					##(enabled, title, url, user, pass)
					old_default_title = old_default_acc[1]
					old_def_url = old_default_acc[2]
					old_def_user = old_default_acc[3]
					old_def_system = old_default_acc[4]
					old_def_pass = old_default_acc[5]
					old_def_blogid = old_default_acc[6]
					old_def_blogtitle = old_default_acc[7]

					old_default_acc = (False, old_default_title, old_def_url, old_def_user, old_def_system, old_def_pass, old_def_blogid, old_def_blogtitle)
					#print 'def false acc modifi: ', old_default_acc
					cuentas[indice] = old_default_acc

					new_default_acc = cuentas[true_indice]
					##(enabled, title, url, user, pass)
					new_default_title = new_default_acc[1]
					new_def_url = new_default_acc[2]
					new_def_user = new_default_acc[3]
					new_def_system = new_default_acc[4]
					new_def_pass = new_default_acc[5]
					new_def_blogid = new_default_acc[6]
					new_def_blogtitle = new_default_acc[7]

					new_default_acc = (True, new_default_title, new_def_url, new_def_user, new_def_system, new_def_pass, new_def_blogid, new_def_blogtitle)
					
					BlogSettings.URL = new_def_url
					BlogSettings.Username = new_def_user
					BlogSettings.Password = new_def_pass 
					BlogSettings.System = new_def_system
					BlogSettings.Blogid = new_def_blogid
					BlogSettings.Blogtitle = new_def_blogtitle
					#print 'NUEVOS SETTINGS: %s %s %s' % (BlogSettings.URL, BlogSettings.Username, BlogSettings.System, BlogSettings.Password)
					
					#print 'def true acc modifi: ', new_default_acc
					cuentas[true_indice] = new_default_acc
				except:
					print 'some error with accounts :)'
			
			#print cuentas
			
			accounts_file=open(configdir + 'accounts.conf', 'w')
			for title_account in accounts.sections():
				accounts.set(title_account, "enabled", 'False')
			accounts.set(newtitle, "enabled", 'True')
			accounts.write(accounts_file)
			accounts_file.close()
			
			##poner la cuenta default en blogsettings

	def make_default(self, path):
		for i in range(len(self.model)):
			newiter = self.model.get_iter((int(i),))
			newfixed = self.model.get_value(newiter, ENABLED)
			newfixed = not newfixed
			self.model.set(newiter, ENABLED, False)	
		
		if path == None:
			if len(self.model)-1 >= 0:
				one_iter = self.model.get_iter((int(len(self.model)-1),))
				fixed = self.model.get_value(one_iter, ENABLED)
				fixed = not fixed
				self.model.set(one_iter, ENABLED, fixed)
				new_default_title = self.model.get_value(one_iter, ACCOUNTTITLE)
			else:
				new_default_title = None
				fixed = None
				one_iter = None
		else:		
			one_iter = self.model.get_iter((int(path),))
			fixed = self.model.get_value(one_iter, ENABLED)
			fixed = not fixed
			self.model.set(one_iter, ENABLED, fixed)
			new_default_title = None	
			
		return new_default_title, fixed, one_iter
			
	def GetAccounts(self):
		for section in accounts.sections():
			title = section
			enabled = accounts.get(section, "enabled")
			if enabled == 'True':
				enabled = True
			elif enabled == 'False':
				enabled = False		
			url = accounts.get(section, "url")
			user = accounts.get(section, "user")
			blogsystem = accounts.get(section, "blogsystem")
			password = accounts.get(section, "password")
			blogid = accounts.get(section, "blogid")
			blogtitle = accounts.get(section, "blogtitle")
			account = (enabled, title, url, user, blogsystem, password, blogid, blogtitle)
			cuentas.append(account)
		#print 'obtengo accounts: ', cuentas
		
	def on_add_clicked(self, widget, treeview, modify):
		self.acctree=gtk.glade.XML(preferences_glade)
		add_dialog  = self.acctree.get_widget("dialog1")
		add_dialog.set_transient_for(self.Preferences_win)
		add_dialog.add_buttons("Save", gtk.RESPONSE_OK, "Cancel", gtk.RESPONSE_CLOSE)
		
		title = self.acctree.get_widget("entry1")
		url = self.acctree.get_widget("entry2")
		user = self.acctree.get_widget("entry3")
		password = self.acctree.get_widget("entry4")
		blogsystem = self.acctree.get_widget("comboboxentry1")
		child = blogsystem.child
		child.set_property("editable", False)	
		blogsystem.set_active(0)

		del blogs[:]
		del blogs_id[:]

		self.blog_list = gtk.ListStore(gobject.TYPE_STRING)		
		self.comboblogs = gtk.ComboBoxEntry(self.blog_list, 0)	
		self.comboblogs.show()
		comboblogs_entry = self.comboblogs.child
		comboblogs_entry.set_property("editable", False)
		hbox12 = self.acctree.get_widget("hbox12")
		hbox12.pack_start(self.comboblogs, True, True, 0)
		hbox12.reorder_child(self.comboblogs, 1)
		hbox12.hide()
		get_blogs_btn = self.acctree.get_widget("get_blogs_btn")
		get_blogs_btn.connect("clicked", self.on_get_blogs_clicked, user, password)

		hbox4 = self.acctree.get_widget("hbox4")
		blogsystem.connect("changed", self.on_system_changed, hbox4, hbox12)

		if modify == True:
			add_dialog.set_title('Modify account')
			title.set_text(self.modify_title)
			url.set_text(self.modify_url)
			user.set_text(self.modify_user)
			password.set_text(self.modify_password)
			if self.modify_blogsystem == "Wordpress":
				blogsystem.set_active(0)
			else:
				blogsystem.set_active(1)
				hbox4.hide()
				hbox12.show()
				self.blog_list.append((self.modify_blogtitle,))	
				self.comboblogs.set_active(0)
			
		
		add_dialog.show()
		result = add_dialog.run()
		
		if (result==gtk.RESPONSE_OK):
			if title.get_text() == '':
				add_dialog.destroy()
				return

			if blogsystem.get_active_text() == 'Wordpress':
				blogid = 'None'
				blogtitle = 'None'
				self.set_new_account(treeview, title, url, user, blogsystem, password, blogid, blogtitle, False)
			else:
				try:
					if modify == True:
						try:
							active = self.comboblogs.get_active()
							blogid = blogs_id[active]
							blogtitle = blogs[active]
						except:
							blogtitle = self.modify_blogtitle
							blogid = self.modify_blogid	
						self.set_new_account(treeview, title, url, user, blogsystem, password, blogid, blogtitle, False)
					else:
						active = self.comboblogs.get_active()
						blogid = blogs_id[active]
						blogtitle = blogs[active]
						self.set_new_account(treeview, title, url, user, blogsystem, password, blogid, blogtitle, False)
				except:
					app.show_error_dlg("Remember, you need to add a blog.")
					blogid = 'None'
					blogtitle = 'None'
					self.set_new_account(treeview, title, url, user, blogsystem, password, blogid, blogtitle, False)

		add_dialog.destroy()
		
		return result

	def on_system_changed(self, widget, hbox4, hbox12):
		if widget.get_active() == 1:
			hbox4.hide()
			hbox12.show()
		else:
			hbox4.show()
			hbox12.hide()

	def on_get_blogs_clicked(self, widget, user, password):
		banner = hildon.hildon_banner_show_animation(widget, 'qgn_indi_pball_a', 'Getting blogs')
		thread.start_new_thread(self.on_get_blog_list, (user, password, banner))		

	def on_get_blog_list(self, user, password, banner):

		del blogs[:]
		del blogs_id[:]

		try:
			service = gdata.service.GDataService(user.get_text(), password.get_text())
			service.source = 'Maemo WordPy'
			service.service = 'blogger'
			service.server = 'www.blogger.com'
			service.ProgrammaticLogin()
		
			feed = service.Get('/feeds/default/blogs')

			for i in range(len(feed.entry)):
				blogs.append(feed.entry[i].title.text)
				blogs_id.append(feed.entry[i].id.text.split('-')[-1])

			self.blog_list.clear()

			for item in blogs:
				self.blog_list.append((item,))	
			self.comboblogs.set_active(0)

			banner.destroy()

		except gdata.service.BadAuthentication, e:
			banner.destroy()
			thread.start_new_thread(app.error_post, ('Error: %s' % e,))
		except:
			banner.destroy()
			thread.start_new_thread(app.error_post, ('Error getting blogs.\nDo you have an internet connection?',))
			

	def set_new_account(self, treeview, title, url, user, blogsystem, password, blogid, blogtitle, modify):
		if modify == False:
			#print 'no modify'
			newtitle = title.get_text()
			newurl = url.get_text()
			newuser = user.get_text()
			newblogsystem = blogsystem.get_active_text()
			newpassword = password.get_text()
			newblogid = blogid
			newblogtitle = blogtitle
		elif modify == True:
			#print 'modify'
			newtitle = self.modify_title
			newurl = self.modify_url
			newuser = self.modify_user
			newblogsystem = self.modify_blogsystem
			newpassword = self.modify_password
			newblogid = self.modify_blogid
			newblogtitle = self.modify_blogtitle	
	
		newaccount = (True, newtitle, newurl, newuser, newblogsystem, newpassword, newblogid, newblogtitle) 
		#print 'new:', newaccount
		#print 'acc:', cuentas
		BlogSettings.URL = newurl
		BlogSettings.Username = newuser
		BlogSettings.Password = newpassword
		BlogSettings.System = newblogsystem
		BlogSettings.Blogid = newblogid
		BlogSettings.Blogtitle = newblogtitle
		#print 'NUEVOS SETTINGS: %s %s %s %s' % (BlogSettings.URL, BlogSettings.Username, BlogSettings.System, BlogSettings.Password)
		
		for i in cuentas:
			if str(i).find('True') >= 0:
				indice = cuentas.index(i)
				
		if cuentas == []:
			pass
		else:
			old_default_acc = cuentas[indice]
			##(enabled, title, url, user, pass)
			old_default_title = old_default_acc[1]
			old_def_url = old_default_acc[2]
			old_def_user = old_default_acc[3]
			old_def_system = old_default_acc[4]
			old_def_pass = old_default_acc[5]
			old_def_blogid = old_default_acc[6]
			old_def_blogtitle = old_default_acc[7]
		 
			old_default_acc = (False, old_default_title, old_def_url, old_def_user, old_def_system, old_def_pass, old_def_blogid, old_def_blogtitle)
			#print 'def acc modifi: ', old_default_acc
			cuentas[indice] = old_default_acc

		cuentas.append(newaccount)
		#print cuentas
		
		self.model = self.__accounts_model()
		treeview.set_model(self.model)
		
		##poner default a una nada mas
		self.make_default(None)

		accounts_file=open(configdir + 'accounts.conf', 'w')
		try:
			for title_account in accounts.sections():
				accounts.set(title_account, "enabled", 'False')
			accounts.add_section(newtitle)
			accounts.set(newtitle, "enabled", 'True')
			accounts.set(newtitle, "url", newurl)
			accounts.set(newtitle, "user", newuser)
			accounts.set(newtitle, "blogsystem", newblogsystem)
			accounts.set(newtitle, "password", newpassword)
			accounts.set(newtitle, "blogid", newblogid)
			accounts.set(newtitle, "blogtitle", newblogtitle)
			accounts.write(accounts_file)
			accounts_file.close()
		except ConfigParser.NoOptionError, e:
			print e
		except ConfigParser.NoSectionError, e:
			self.write_default_accounts(accounts_file)
		except ConfigParser.DuplicateSectionError:
			app.show_error_dlg("Account '%s' already exists." % newtitle)
			##delete the duplicate account created##
			cuentas.pop()
			self.model = self.__accounts_model()
			treeview.set_model(self.model)
			self.make_default(None)


	def write_initial_accounts(self, accounts_file):
		accounts.add_section("Test-blog")
		##false o true???
		accounts.set(newtitle, "enabled", 'False')
		accounts.set(newtitle, "url", 'http://blogsite.com/xmlrpc.php')
		accounts.set(newtitle, "user", 'user')	
		accounts.set(newtitle, "blogsystem", 'Wordpress')						
		accounts.set(newtitle, "password", 'password')
		accounts.set(newtitle, "blogid", 'None')
		accounts.set(newtitle, "blogtitle", 'None')
		accounts.write(accounts_file)
		accounts_file.close()	

	def on_delete_clicked(self, widget, treeview):		
		selection = treeview.get_selection()
		hele, iter = selection.get_selected()
		if iter:
			title = self.model.get_value(iter, ACCOUNTTITLE)
			enabled = self.model.get_value(iter, ENABLED)
			url = self.model.get_value(iter, BLOGURL)
			user = self.model.get_value(iter, BLOGUSER)
			blogsystem = self.model.get_value(iter, BLOGSYSTEM)
			password = self.model.get_value(iter, BLOGPASS)
			blogid = self.model.get_value(iter, BLOGID)
			blogtitle = self.model.get_value(iter, BLOGTITLE)
		else:
			print 'not selection.'
			return

		if enabled == True:
			delaccount = (True, title, url, user, blogsystem, password, blogid, blogtitle)
		elif enabled == False:
			delaccount = (False, title, url, user, blogsystem, password, blogid, blogtitle)
			
		#print 'delaccount: ', delaccount
		#print 'accounts: ', cuentas
		cuentas.remove(delaccount)
		#print 'final accounts: ', cuentas
		
		#recrear el treeview
		self.model = self.__accounts_model()
		treeview.set_model(self.model)
			
		new_default_title, afixed, aniter = self.make_default(None)
		if new_default_title == None:
			pass
		else:
			#print new_default_title

			for i in cuentas:
				if str(i).find(new_default_title) >= 0:
					indice = cuentas.index(i)

			new_default_acc = cuentas[indice]
			#print 'default acc sin modifi: ', new_default_acc
			##(enabled, title, url, user, pass)
			new_def_url = new_default_acc[2]
			new_def_user = new_default_acc[3]
			new_def_system = new_default_acc[4]
			new_def_pass = new_default_acc[5]
			new_def_blogid = new_default_acc[6]
			new_def_blogtitle = new_default_acc[7]
		 
			new_default_acc = (True, new_default_title, new_def_url, new_def_user, new_def_system, new_def_pass, new_def_blogid, new_def_blogtitle)
			#print 'def acc modifi: ', new_default_acc
			cuentas[indice] = new_default_acc
			#print 'accounts modifi: ', cuentas
				
			BlogSettings.URL = new_def_url
			BlogSettings.Username = new_def_user
			BlogSettings.Password = new_def_pass 
			BlogSettings.System = new_def_system 
			BlogSettings.Blogid = new_def_blogid 
			BlogSettings.Blogtitle = new_def_blogtitle
			#print 'NUEVOS SETTINGS: %s %s %s %s' % (BlogSettings.URL, BlogSettings.Username, BlogSettings.System, BlogSettings.Password)
		
		accounts_file=open(configdir + 'accounts.conf', 'w')
		try:
			for title_account in accounts.sections():
				accounts.set(title_account, "enabled", 'False')
			accounts.set(new_default_title, "enabled", 'True')
			accounts.remove_section(title)	
			accounts.write(accounts_file)
			accounts_file.close()
		except ConfigParser.NoOptionError, e:
			print e
		except ConfigParser.NoSectionError, e:
			print e
			
	def on_modify_clicked(self, widget, treeview):		
		selection = treeview.get_selection()
		hele, iter = selection.get_selected()
		if iter:
			self.modify_title = self.model.get_value(iter, ACCOUNTTITLE)
			enabled = self.model.get_value(iter, ENABLED)
			self.modify_url = self.model.get_value(iter, BLOGURL)
			self.modify_user = self.model.get_value(iter, BLOGUSER)
			self.modify_blogsystem = self.model.get_value(iter, BLOGSYSTEM)
			self.modify_password = self.model.get_value(iter, BLOGPASS)
			self.modify_blogid = accounts.get(self.modify_title, "blogid")
			self.modify_blogtitle = accounts.get(self.modify_title, "blogtitle")
		else:
			print 'not selection.'
			return

		if enabled == True:
			delaccount = (True, self.modify_title, self.modify_url, self.modify_user, self.modify_blogsystem, self.modify_password, self.modify_blogid, self.modify_blogtitle)
		elif enabled == False:
			delaccount = (False, self.modify_title, self.modify_url, self.modify_user, self.modify_blogsystem, self.modify_password, self.modify_blogid, self.modify_blogtitle)
		cuentas.remove(delaccount)
		
		self.model = self.__accounts_model()
		new_default_title, afixed, aniter = self.make_default(None)
		if new_default_title == None:
			pass
		else:
			#print new_default_title

			for i in cuentas:
				if str(i).find(new_default_title) >= 0:
					indice = cuentas.index(i)

			new_default_acc = cuentas[indice]
			#print 'default acc sin modifi: ', new_default_acc
			##(enabled, title, url, user, pass)
			new_def_url = new_default_acc[2]
			new_def_user = new_default_acc[3]
			new_def_system = new_default_acc[4]
			new_def_pass = new_default_acc[5]
			new_def_blogid = new_default_acc[6]
			new_def_blogtitle = new_default_acc[7]
		 
			new_default_acc = (True, new_default_title, new_def_url, new_def_user, new_def_system, new_def_pass, new_def_blogid, new_def_blogtitle)
			#print 'def acc modifi: ', new_default_acc
			cuentas[indice] = new_default_acc
			#print 'accounts modifi: ', cuentas
				
			BlogSettings.URL = new_def_url
			BlogSettings.Username = new_def_user
			BlogSettings.System = new_def_system
			BlogSettings.Password = new_def_pass
			BlogSettings.Blogid  = new_def_blogid
			BlogSettings.Blogtitle  = new_def_blogtitle
			#print 'NUEVOS SETTINGS: %s %s %s %s' % (BlogSettings.URL, BlogSettings.Username, BlogSettings.System, BlogSettings.Password)
		
		accounts_file=open(configdir + 'accounts.conf', 'w')
		try:
			accounts.remove_section(self.modify_title)	
			accounts.write(accounts_file)
			accounts_file.close()
		except ConfigParser.NoOptionError, e:
			print e
		except ConfigParser.NoSectionError, e:
			print e	
		
		result = self.on_add_clicked(widget, treeview, True)

		if (result==gtk.RESPONSE_CLOSE):
			self.set_new_account(treeview, self.modify_title, self.modify_url, self.modify_user, self.modify_blogsystem, self.modify_password, self.modify_blogid, self.modify_blogtitle, True)
		
	def on_authorize_flickr(self, widget):
		try:
			(token, frob) = flickr.getTokenPartOne(perms='write', context=osso_c) 

			if not token:
				dialog = gtk.Dialog(title='Authorize Flickr', parent=None, flags=gtk.WIN_POS_CENTER, buttons=(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE))
				dialog.set_transient_for(self.Preferences_win)
		
				label = gtk.Label("Press when authorize from flickr")
				dialog.vbox.pack_start(label, True, True, 0)	
	
				dialog.show_all()
		
				dialog.run()
				dialog.destroy()
			if token:
				app.show_error_dlg("You already have authorized Flickr access.")

			flickr.getTokenPartTwo((token, frob)) 

		except flickrapi.FlickrError, e:
			app.show_error_dlg("Flickr error:\nMessage: %s" % e)
			return

		
class FlickrUpload:
	def __init__(self):
		self.wTree=gtk.glade.XML(upload_glade)
		self.flickr_dialog = self.wTree.get_widget("dialog1")
		self.flickr_dialog.set_title('Flickr upload')
		self.flickr_dialog.set_transient_for(app.wndMain)
		self.flickr_dialog.add_button('Close', gtk.RESPONSE_CLOSE)
		
		self.sets_id_chosen = False
		
		image1 = self.wTree.get_widget("image1")
		
		button2 = self.wTree.get_widget("button2")
		button2.connect("clicked", self.browse_for_image, image1)

		button4 = self.wTree.get_widget("button4")
		button4.connect("clicked", app.on_help, 'flickr_upload')
		
		self.title_entry = self.wTree.get_widget("entry1")
		self.tags_entry = self.wTree.get_widget("entry2")
		
		description = self.wTree.get_widget("textview1")
		self.buffer1 = description.get_buffer()
		
		self.upload_btn = self.wTree.get_widget("button1")
		self.upload_btn.set_sensitive(False)
		self.upload_btn.connect("clicked", self.upload)
		
		sets_btn = self.wTree.get_widget("button3")
		sets_btn.connect("clicked", self.on_sets_clicked)
		
		self.public_button = self.wTree.get_widget("radiobutton3")
		self.public_button.set_active(True)
		self.public_button.connect('toggled', self.on_public_active)
		
		self.private_button = self.wTree.get_widget("radiobutton4")

		self.friends_button = self.wTree.get_widget("checkbutton1")
		self.family_button = self.wTree.get_widget("checkbutton2")
		
		self.do_private_widgets_insensitive()
		
		self.flickr_dialog.show_all()
		self.flickr_dialog.run()
		self.flickr_dialog.destroy()
		
	def on_public_active(self, widget):
		if self.public_button.get_active():
			self.do_private_widgets_insensitive()
		else:
			self.friends_button.set_sensitive(True)
			self.family_button.set_sensitive(True)
		
	def do_private_widgets_insensitive(self):
		self.friends_button.set_sensitive(False)
		self.family_button.set_sensitive(False)
		self.family_button.set_active(False)
		self.friends_button.set_active(False)
		
	def upload(self, widget):
		banner = hildon.hildon_banner_show_animation(widget, 'qgn_indi_pball_a', 'Uploading image to Flickr')
		start, end = self.buffer1.get_bounds()
		description = self.buffer1.get_text(start, end)

		tags = self.tags_entry.get_text()
		title = self.title_entry.get_text()	
		
		filename = self.filename
		
		if self.public_button.get_active():
			public = "1"
			family = "0"
			friend = "0"
		elif self.private_button.get_active():
			public = "0"
			if self.friends_button.get_active():
				friend = "1"
			else:
				friend = "0"
			if self.family_button.get_active():
				family = "1"
			else:
				family = "0"		
		thread.start_new_thread(self.upload_image,  (banner, filename, title, description, tags, public, friend, family))

	def upload_image(self, banner, filename, title, description, tags, public, friend, family):
		try:
			photo_id = flickr.upload(filename=filename, title=title, description=description, tags=tags, is_public=public, is_friend=friend, is_family=family)

			self.upload_id = photo_id.photoid[0].elementText

			if self.sets_id_chosen != False:
				flickr.photosets_addPhoto(photoset_id=self.sets_id_chosen, photo_id=self.upload_id)
			self.sets_id_chosen = False
			banner.destroy()
			thread.start_new_thread(app.success_dlg, ('Flickr upload succesful.',))
		except flickrapi.FlickrError, e:
			banner.destroy()
			gtk.gdk.threads_enter()
			app.show_error_dlg("Flickr error: %s." %e)
			gtk.gdk.threads_leave()
		except:	
			gtk.gdk.threads_enter()
			banner.destroy()
			gtk.gdk.threads_leave()
			gtk.gdk.threads_enter()
			app.show_error_dlg("Error uploading image to Flickr.\nDo you have an internet connection?")
			gtk.gdk.threads_leave()

	def on_sets_clicked(self, widget):
		dialog = gtk.Dialog(title='Choose Set', parent=None, buttons=('Cancel', gtk.RESPONSE_CANCEL, 'Choose', gtk.RESPONSE_OK))
		dialog.set_transient_for(self.flickr_dialog)
		dialog.set_size_request(400, -1)
		dialog.set_default_response(gtk.RESPONSE_OK)
		del sets[:]
		del sets_id[:]
		self.setslist = gtk.ListStore(gobject.TYPE_STRING)		
		self.combosets = gtk.ComboBoxEntry(self.setslist, 0)	
		photos_entry = self.combosets.child
		photos_entry.set_property("editable", False)
		try:
			lista = flickr.photosets_getList()
		except flickrapi.FlickrError, e:
			app.show_error_dlg("Flickr error: %s.\n" %e)
			return
		except:
			app.show_error_dlg("Error getting Flickr sets.\nDo you have an internet connection?")
			return
		for i in range(len(lista.photosets[0].photoset)):
			sets.append(lista.photosets[0].photoset[i].title[0].elementText)
			sets_id.append(lista.photosets[0].photoset[i]['id'])	

		for item in sets:
			self.setslist.append((item,))	
		self.combosets.set_active(0)		
		
		dialog.vbox.pack_start(self.combosets, False, False, 0)

		dialog.show_all()
		if dialog.run() == gtk.RESPONSE_OK:
			active = self.combosets.get_active()
			self.set_chosen = str(sets[active])
			self.sets_id_chosen = sets_id[active]

		dialog.destroy()

	def browse_for_image(self, widget, image):
		dialog = hildon.FileChooserDialog(app.wndMain, gtk.FILE_CHOOSER_ACTION_OPEN)
		dialog.set_title("Browse Image")
		dialog.set_transient_for(self.flickr_dialog)
		dialog.set_default_response(gtk.RESPONSE_OK)
		dialog.set_current_folder('/home/user/MyDocs/.images')
		
		self.sets_id_chosen = False

		result = ""
		if dialog.run() == gtk.RESPONSE_OK:
			try:
				result = dialog.get_filename()
				self.new_pixbuf = gtk.gdk.pixbuf_new_from_file(result)
				self.filename = result
				w, h = self.set_thumbnail_size(self.new_pixbuf)
			
				scale_pixbuf = self.new_pixbuf.scale_simple(int(w), int(h), gtk.gdk.INTERP_BILINEAR)
				del self.new_pixbuf
				image.set_from_pixbuf(scale_pixbuf)
				del scale_pixbuf
				image.show()
				self.upload_btn.set_sensitive(True)
			except:
				print 'No image file.'
				result = None
		dialog.destroy()

		return result
		
	def set_thumbnail_size(self, pixbuf):
		pix_width = pixbuf.get_width()
		pix_height = pixbuf.get_height()
		
		if pix_width > pix_height:
			w = 100
			h = float(pix_height)/float(pix_width) * 100
		elif pix_height > pix_width:
			h = 100
			w = float(pix_width)/float(pix_height) * 100
		elif pix_height == pix_width:
			h = 100
			w = 100
		else:
			print "Pixbuf size can't be calculated."

		return w, h
		

if __name__ == "__main__":
	BlogSettings = WordPressBlogSettings()
	app = Wordpy()
	gtk.gdk.threads_enter()
	gtk.main()
	gtk.gdk.threads_leave()
